## Pashupati Mishra
## Liisa Holm's Bioinformatics lab
## Institute of Biotechnology, University of Helsinki
## 28.06.2016

generatePermCumsumDataBrca <- function(data,top=c(3,5,7)){

### This code generates cumulative sum data for each data splits
### Input is a list of results from 100 data splits. 
### Output is a list of all the cumulative data from each of the data splits


    listOfCumSum <- list()
    iter <- length(data)
    
    for(i in 1:iter){
    
        gsz_reference <- data[[i]][[1]]
        gsa_reference <- data[[i]][[2]]
        allez_reference <- data[[i]][[3]]
        wks_reference <- data[[i]][[4]]
        camera_reference <- data[[i]][[5]]
        qusage_reference <- data[[i]][[6]]
        gage_reference_mixed <- data[[i]][[7]]
        
        perm1_test <- data[[i]][[9]]
        perm2_test <- data[[i]][[10]]
        perm3_test <- data[[i]][[11]]
        perm4_test <- data[[i]][[12]]
        perm5_test <- data[[i]][[13]]
        perm6_test <- data[[i]][[14]]

        
        pos_sets1 <- unique(c(as.character(gsz_reference[,1])[1:top[1]],as.character(gsa_reference[,1])[1:top[1]], as.character(allez_reference[,1])[1:top[1]], as.character(wks_reference[,1])[1:top[1]], rownames(camera_reference)[1:top[1]], rownames(gage_reference_mixed)[1:top[1]], as.character(qusage_reference[,1])[1:top[1]]))
        
        pos_sets2 <- unique(c(as.character(gsz_reference[,1])[1:top[2]],as.character(gsa_reference[,1])[1:top[2]], as.character(allez_reference[,1])[1:top[2]],as.character(wks_reference[,1])[1:top[2]], rownames(camera_reference)[1:top[2]], rownames(gage_reference_mixed)[1:top[2]], as.character(qusage_reference[,1])[1:top[2]]))
        
        pos_sets3 <- unique(c(as.character(gsz_reference[,1])[1:top[3]],as.character(gsa_reference[,1])[1:top[3]], as.character(allez_reference[,1])[1:top[3]],  as.character(wks_reference[,1])[1:top[3]], rownames(camera_reference)[1:top[3]], rownames(gage_reference_mixed)[1:top[3]], as.character(qusage_reference[,1])[1:top[3]]))
    
    
    
   ### creating binary vectors for plot with pos_sets1
        
    perm1_test_4cumsum <- cbind(gene_sets=as.character(perm1_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm1_test_4cumsum[,1] %in% pos_sets1)
    perm1_test_4cumsum[ind,2] <- 1
    
    
    perm2_test_4cumsum <- cbind(gene_sets=as.character(perm2_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm2_test_4cumsum[,1] %in% pos_sets1)
    perm2_test_4cumsum[ind,2] <- 1
    
    
    perm4_test_4cumsum <- cbind(gene_sets=as.character(perm4_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm4_test_4cumsum[,1] %in% pos_sets1)
    perm4_test_4cumsum[ind,2] <- 1
    
    
    perm3_test_4cumsum <- cbind(gene_sets=as.character(perm3_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm3_test_4cumsum[,1] %in% pos_sets1)
    perm3_test_4cumsum[ind,2] <- 1
    
    perm5_test_4cumsum <- cbind(gene_sets=as.character(perm5_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm5_test_4cumsum[,1] %in% pos_sets1)
    perm5_test_4cumsum[ind,2] <- 1
    
    
    perm6_test_4cumsum <- cbind(gene_sets=as.character(perm6_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm6_test_4cumsum[,1] %in% pos_sets1)
    perm6_test_4cumsum[ind,2] <- 1
    
    
    
    data_split1 <- cbind(as.numeric(perm1_test_4cumsum[,2]),as.numeric(perm2_test_4cumsum[,2]),as.numeric(perm4_test_4cumsum[,2]),as.numeric(perm3_test_4cumsum[,2]),as.numeric(perm5_test_4cumsum[,2]),as.numeric(perm6_test_4cumsum[,2]))
    

colnames(data_split1) <- c("Perm1","Perm2","Perm4","Perm3","Perm5","Perm6")

 
 ######## ### creating binary vectors for plot with pos_sets2 #######

    perm1_test_4cumsum <- cbind(gene_sets=as.character(perm1_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm1_test_4cumsum[,1] %in% pos_sets2)
    perm1_test_4cumsum[ind,2] <- 1
    
    
    perm2_test_4cumsum <- cbind(gene_sets=as.character(perm2_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm2_test_4cumsum[,1] %in% pos_sets2)
    perm2_test_4cumsum[ind,2] <- 1
    
    
    perm4_test_4cumsum <- cbind(gene_sets=as.character(perm4_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm4_test_4cumsum[,1] %in% pos_sets2)
    perm4_test_4cumsum[ind,2] <- 1
    
    
    perm3_test_4cumsum <- cbind(gene_sets=as.character(perm3_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm3_test_4cumsum[,1] %in% pos_sets2)
    perm3_test_4cumsum[ind,2] <- 1
    
    perm5_test_4cumsum <- cbind(gene_sets=as.character(perm5_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm5_test_4cumsum[,1] %in% pos_sets2)
    perm5_test_4cumsum[ind,2] <- 1
    
    
    perm6_test_4cumsum <- cbind(gene_sets=as.character(perm6_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm6_test_4cumsum[,1] %in% pos_sets2)
    perm6_test_4cumsum[ind,2] <- 1
    
    
    
    data_split2 <- cbind(as.numeric(perm1_test_4cumsum[,2]),as.numeric(perm2_test_4cumsum[,2]),as.numeric(perm4_test_4cumsum[,2]),as.numeric(perm3_test_4cumsum[,2]),as.numeric(perm5_test_4cumsum[,2]),as.numeric(perm6_test_4cumsum[,2]))
    

colnames(data_split2) <- c("Perm1","Perm2","Perm4","Perm3","Perm5","Perm6")


### creating binary vectors for plot with pos_sets3

    perm1_test_4cumsum <- cbind(gene_sets=as.character(perm1_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm1_test_4cumsum[,1] %in% pos_sets3)
    perm1_test_4cumsum[ind,2] <- 1
    
    
    perm2_test_4cumsum <- cbind(gene_sets=as.character(perm2_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm2_test_4cumsum[,1] %in% pos_sets3)
    perm2_test_4cumsum[ind,2] <- 1
    
    
    perm4_test_4cumsum <- cbind(gene_sets=as.character(perm4_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm4_test_4cumsum[,1] %in% pos_sets3)
    perm4_test_4cumsum[ind,2] <- 1
    
    
    perm3_test_4cumsum <- cbind(gene_sets=as.character(perm3_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm3_test_4cumsum[,1] %in% pos_sets3)
    perm3_test_4cumsum[ind,2] <- 1
    
    perm5_test_4cumsum <- cbind(gene_sets=as.character(perm5_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm5_test_4cumsum[,1] %in% pos_sets3)
    perm5_test_4cumsum[ind,2] <- 1
    
    
    perm6_test_4cumsum <- cbind(gene_sets=as.character(perm6_test[,1])[1:50],counts=rep(0,50))
    ind <- which(perm6_test_4cumsum[,1] %in% pos_sets3)
    perm6_test_4cumsum[ind,2] <- 1
    
    
    
    data_split3 <- cbind(as.numeric(perm1_test_4cumsum[,2]),as.numeric(perm2_test_4cumsum[,2]),as.numeric(perm4_test_4cumsum[,2]),as.numeric(perm3_test_4cumsum[,2]),as.numeric(perm5_test_4cumsum[,2]),as.numeric(perm6_test_4cumsum[,2]))
    

colnames(data_split3) <- c("Perm1","Perm2","Perm4","Perm3","Perm5","Perm6")

cumulative1 <- apply(data_split1,2,cumsum)
cumulative2 <- apply(data_split2,2,cumsum)
cumulative3 <- apply(data_split3,2,cumsum)
cumulative <- (cumulative1 + cumulative2 + cumulative3)/3


    listOfCumSum[[i]] <- cumulative
    return(listOfCumSum)

    }
}

##################

