### R code for plotting results from split experiment ### ###

## R code to plot mouse tissue specific evaluation

plot_cumsum <- function(gsz,gsa,allez,wks,camera,qusage,gage,romer,pos_sets){

    

    
    ### creating binary vectors for plot
    
     
    gsz4cumsum <- cbind(gene_sets=as.character(gsz[,1])[1:50],counts=rep(0,50))
    ind <- which(gsz4cumsum[,1] %in% pos_sets)
    gsz4cumsum[ind,2] <- 1


    camera4cumsum <- cbind(gene_sets=rownames(camera)[1:50],counts=rep(0,50))
    ind <- which(camera4cumsum[,1] %in% pos_sets)
    camera4cumsum[ind,2] <- 1
    
    gage4cumsum <- cbind(gene_sets=rownames(gage)[1:50],counts=rep(0,50))
    ind <- which(gage4cumsum[,1] %in% pos_sets)
    gage4cumsum[ind,2] <- 1

    gsa4cumsum <- cbind(gene_sets=as.character(gsa[,1])[1:50],counts=rep(0,50))
    ind <- which(gsa4cumsum[,1] %in% pos_sets)
    gsa4cumsum[ind,2] <- 1

    allez4cumsum <- cbind(gene_sets=as.character(rownames(allez))[1:50],counts=rep(0,50))
    ind <- which(allez4cumsum[,1] %in% pos_sets)
    allez4cumsum[ind,2] <- 1


    qusage4cumsum <- cbind(gene_sets=as.character(qusage[,1])[1:50],counts=rep(0,50))
    ind <- which(qusage4cumsum[,1] %in% pos_sets)
    qusage4cumsum[ind,2] <- 1

    wks4cumsum <- cbind(gene_sets=as.character(wks[,1])  [1:50],counts=rep(0,50))
    ind <- which(wks4cumsum[,1] %in% pos_sets)
    wks4cumsum[ind,2] <- 1
    
    romer4cumsum <- cbind(gene_sets=as.character(rownames(romer))  [1:50],counts=rep(0,50))
    ind <- which(romer4cumsum[,1] %in% pos_sets)
    romer4cumsum[ind,2] <- 1
    
    


    ## plot ##
    
    data <- cbind(as.numeric(romer4cumsum[,2]),as.numeric(gage4cumsum[,2]),as.numeric(qusage4cumsum[,2]),as.numeric(wks4cumsum[,2]),as.numeric(camera4cumsum[,2]),as.numeric(allez4cumsum[,2]),as.numeric(gsa4cumsum[,2]),as.numeric(gsz4cumsum[,2]))

 colnames(data) <- c("romer","GAGE","QuSAGE","wKS","CAMERA","Allez","mGSA","mGSZm")

cumsumPlot(data)
 
 
    
}

### sub-function ###


##################

### R function to do cumulative sum plot ###

cumsumPlot <- function(data,cex_val=0.5,lwd_val=3,legend="up"){
    color_pal <- c("grey","red","green","blue","magenta","brown","darkgoldenrod","black")

    line_types <- 1:10
    point_types <- 1:7
    color_pal <- rep(color_pal, 4)
    line_types <- rep(line_types, 4)
    point_types <- rep(point_types, 4)
    ylimits <- c(0,max(colSums(data)+1))
    dat_sz <- dim(data)
    point_inds <- round(seq(1,dat_sz[1], dat_sz[1]/30))
    
    for(i in 1:ncol(data)){
        if(i ==1){
            plot(cumsum(data[,i]), type="l",col=color_pal[i],lty=line_types[i],ylim=ylimits,lwd=lwd_val, cex=cex_val, ylab="Cumulative count of relevant gene sets",xlab="Top 50 gene sets")
        }
        else{
            lines(cumsum(data[,i]),col=color_pal[i],lty=line_types[i],lwd=lwd_val, cex=cex_val)
        }
        dat <- cumsum(data[,i])
        dat[point_inds] <- -10
        points(dat, col = color_pal[i], pch = point_types[i], cex = cex_val, lwd = lwd_val)
    }
    
    if(legend == "up"){
			legend("topleft", colnames(data),lty = line_types[1:dat_sz[2]], 
			        col = color_pal[1:dat_sz[2]], pch = point_types[1:dat_sz[2]], cex = 0.6,lwd = lwd_val )
    }
    else{
        legend("bottomright", colnames(data),lty = line_types[1:dat_sz[2]],
			        col = color_pal[1:dat_sz[2]], pch = point_types[1:dat_sz[2]], cex = cex_val,lwd = lwd_val )
		}
}
###############