## Pashupati Mishra
## Liisa Holm's Bioinformatics lab
## Institute of Biotechnology, University of Helsinki
## 28.06.2016

generateGszCumsumDataPrimary <- function(data,top=c(3,5,7)){

### This code generates cumulative sum data for each data splits


    listOfCumSum <- list()
    iter <- length(data) # number of data splits
    
    for(i in 1:iter){
        mgsz.ref <- data[[i]][[1]]
        mgsa.ref <- data[[i]][[2]]
        allez.ref <- data[[i]][[3]]
        wks.ref <- data[[i]][[4]]
        camera.ref <- data[[i]][[5]]
        qusage.ref <- data[[i]][[6]]
        gage.ref <- data[[i]][[7]]
        romer.ref <- data[[i]][[8]]
    
        
        mgsz.test <- data[[i]][[9]]
        gsa.test <- data[[i]][[10]]
        wks.test <- data[[i]][[11]]
        camera.test <- data[[i]][[12]]
        qusage.test <- data[[i]][[13]]
        gage.test <- data[[i]][[14]]
        romer.test <- data[[i]][[15]]
        std.allez.test <- data[[i]][[16]][[1]]

        
        pos_sets1 <- unique(c(as.character(rownames(romer.ref))[1:top[1]],as.character(mgsz.ref[,1])[1:top[1]],as.character(mgsa.ref[,1])[1:top[1]], as.character(allez.ref[,1])[1:top[1]], as.character(wks.ref[,1])[1:top[1]], rownames(camera.ref)[1:top[1]], rownames(gage.ref)[1:top[1]], as.character(qusage.ref[,1])[1:top[1]]))
        
        pos_sets2 <- unique(c(as.character(rownames(romer.ref))[1:top[2]],as.character(mgsz.ref[,1])[1:top[2]],as.character(mgsa.ref[,1])[1:top[2]],as.character(allez.ref[,1])[1:top[2]],as.character(wks.ref[,1])[1:top[2]],rownames(camera.ref)[1:top[2]], rownames(gage.ref)[1:top[2]],as.character(qusage.ref[,1])[1:top[2]]))
        
        pos_sets3 <- unique(c(as.character(rownames(romer.ref))[1:top[3]],as.character(mgsz.ref[,1])[1:top[3]],as.character(mgsa.ref[,1])[1:top[3]],as.character(allez.ref[,1])[1:top[3]],as.character(wks.ref[,1])[1:top[3]],rownames(camera.ref)[1:top[3]], rownames(gage.ref)[1:top[3]],as.character(qusage.ref[,1])[1:top[3]]))
    
    
    ### creating binary vectors for plot with pos_sets1
        
    mgsz.test.cumsum <- cbind(gene_sets=as.character(mgsz.test[,1])[1:50],counts=rep(0,50))
    ind <- which(mgsz.test.cumsum[,1] %in% pos_sets1)
    mgsz.test.cumsum[ind,2] <- 1
    
    gsa.test.cumsum <- cbind(gene_sets=as.character(gsa.test[,1])[1:50],counts=rep(0,50))
    ind <- which(gsa.test.cumsum[,1] %in% pos_sets1)
    gsa.test.cumsum[ind,2] <- 1
    
    wks.test.cumsum <- cbind(gene_sets=as.character(wks.test[,1])[1:50],counts=rep(0,50))
    ind <- which(wks.test.cumsum[,1] %in% pos_sets1)
    wks.test.cumsum[ind,2] <- 1
    
    camera.test.cumsum <- cbind(gene_sets=rownames(camera.test)[1:50],counts=rep(0,50))
    ind <- which(camera.test.cumsum[,1] %in% pos_sets1)
    camera.test.cumsum[ind,2] <- 1
    
    qusage.test.cumsum <- cbind(gene_sets=as.character(qusage.test[,1])[1:50],counts=rep(0,50))
    ind <- which(qusage.test.cumsum[,1] %in% pos_sets1)
    qusage.test.cumsum[ind,2] <- 1
    
    gage.test.cumsum <- cbind(gene_sets=rownames(gage.test)[1:50],counts=rep(0,50))
    ind <- which(gage.test.cumsum[,1] %in% pos_sets1)
    gage.test.cumsum[ind,2] <- 1
    
    romer.test.cumsum <- cbind(gene_sets=as.character(rownames(romer.test)[1:50]),counts=rep(0,50))
    ind <- which(romer.test.cumsum[,1] %in% pos_sets1)
    romer.test.cumsum[ind,2] <- 1
    
    std.allez.test.cumsum <- cbind(gene_sets=as.character(rownames(std.allez.test)[1:50]),counts=rep(0,50))
    ind <- which(std.allez.test.cumsum[,1] %in% pos_sets1)
    std.allez.test.cumsum[ind,2] <- 1
        
        
    data_split1 <- cbind(as.numeric(romer.test.cumsum[,2]),as.numeric(gage.test.cumsum[,2]),as.numeric(qusage.test.cumsum[,2]),as.numeric(wks.test.cumsum[,2]),as.numeric(camera.test.cumsum[,2]),as.numeric(std.allez.test.cumsum[,2]),as.numeric(gsa.test.cumsum[,2]),as.numeric(mgsz.test.cumsum[,2]))
    

colnames(data_split1) <- c("romer","GAGE","QuSAGE","wKS","CAMERA","Allez","mGSA","mGSZm")

 
 ######## ### creating binary vectors for plot with pos_sets2 #######

        mgsz.test.cumsum <- cbind(gene_sets=as.character(mgsz.test[,1])[1:50],counts=rep(0,50))
        ind <- which(mgsz.test.cumsum[,1] %in% pos_sets2)
        mgsz.test.cumsum[ind,2] <- 1
        
        gsa.test.cumsum <- cbind(gene_sets=as.character(gsa.test[,1])[1:50],counts=rep(0,50))
        ind <- which(gsa.test.cumsum[,1] %in% pos_sets2)
        gsa.test.cumsum[ind,2] <- 1
        
        wks.test.cumsum <- cbind(gene_sets=as.character(wks.test[,1])[1:50],counts=rep(0,50))
        ind <- which(wks.test.cumsum[,1] %in% pos_sets2)
        wks.test.cumsum[ind,2] <- 1
        
        camera.test.cumsum <- cbind(gene_sets=rownames(camera.test)[1:50],counts=rep(0,50))
        ind <- which(camera.test.cumsum[,1] %in% pos_sets2)
        camera.test.cumsum[ind,2] <- 1
        
        qusage.test.cumsum <- cbind(gene_sets=as.character(qusage.test[,1])[1:50],counts=rep(0,50))
        ind <- which(qusage.test.cumsum[,1] %in% pos_sets2)
        qusage.test.cumsum[ind,2] <- 1
        
        gage.test.cumsum <- cbind(gene_sets=rownames(gage.test)[1:50],counts=rep(0,50))
        ind <- which(gage.test.cumsum[,1] %in% pos_sets2)
        gage.test.cumsum[ind,2] <- 1
        
        romer.test.cumsum <- cbind(gene_sets=as.character(rownames(romer.test)[1:50]),counts=rep(0,50))
        ind <- which(romer.test.cumsum[,1] %in% pos_sets2)
        romer.test.cumsum[ind,2] <- 1
        
        std.allez.test.cumsum <- cbind(gene_sets=as.character(rownames(std.allez.test)[1:50]),counts=rep(0,50))
        ind <- which(std.allez.test.cumsum[,1] %in% pos_sets2)
        std.allez.test.cumsum[ind,2] <- 1
        
        
        
        data_split2 <- cbind(as.numeric(romer.test.cumsum[,2]),as.numeric(gage.test.cumsum[,2]),as.numeric(qusage.test.cumsum[,2]),as.numeric(wks.test.cumsum[,2]),as.numeric(camera.test.cumsum[,2]),as.numeric(std.allez.test.cumsum[,2]),as.numeric(gsa.test.cumsum[,2]),as.numeric(mgsz.test.cumsum[,2]))
        
        
        colnames(data_split2) <- c("romer","GAGE","QuSAGE","wKS","CAMERA","Allez","mGSA","mGSZm")
        
        
### creating binary vectors for plot with pos_sets3

        mgsz.test.cumsum <- cbind(gene_sets=as.character(mgsz.test[,1])[1:50],counts=rep(0,50))
        ind <- which(mgsz.test.cumsum[,1] %in% pos_sets3)
        mgsz.test.cumsum[ind,2] <- 1
        
        gsa.test.cumsum <- cbind(gene_sets=as.character(gsa.test[,1])[1:50],counts=rep(0,50))
        ind <- which(gsa.test.cumsum[,1] %in% pos_sets3)
        gsa.test.cumsum[ind,2] <- 1
        
        wks.test.cumsum <- cbind(gene_sets=as.character(wks.test[,1])[1:50],counts=rep(0,50))
        ind <- which(wks.test.cumsum[,1] %in% pos_sets3)
        wks.test.cumsum[ind,2] <- 1
        
        camera.test.cumsum <- cbind(gene_sets=rownames(camera.test)[1:50],counts=rep(0,50))
        ind <- which(camera.test.cumsum[,1] %in% pos_sets3)
        camera.test.cumsum[ind,2] <- 1
        
        qusage.test.cumsum <- cbind(gene_sets=as.character(qusage.test[,1])[1:50],counts=rep(0,50))
        ind <- which(qusage.test.cumsum[,1] %in% pos_sets3)
        qusage.test.cumsum[ind,2] <- 1
        
        gage.test.cumsum <- cbind(gene_sets=rownames(gage.test)[1:50],counts=rep(0,50))
        ind <- which(gage.test.cumsum[,1] %in% pos_sets3)
        gage.test.cumsum[ind,2] <- 1
        
        romer.test.cumsum <- cbind(gene_sets=as.character(rownames(romer.test)[1:50]),counts=rep(0,50))
        ind <- which(romer.test.cumsum[,1] %in% pos_sets3)
        romer.test.cumsum[ind,2] <- 1
        
        std.allez.test.cumsum <- cbind(gene_sets=as.character(rownames(std.allez.test)[1:50]),counts=rep(0,50))
        ind <- which(std.allez.test.cumsum[,1] %in% pos_sets3)
        std.allez.test.cumsum[ind,2] <- 1
        
        
        
        data_split3 <- cbind(as.numeric(romer.test.cumsum[,2]),as.numeric(gage.test.cumsum[,2]),as.numeric(qusage.test.cumsum[,2]),as.numeric(wks.test.cumsum[,2]),as.numeric(camera.test.cumsum[,2]),as.numeric(std.allez.test.cumsum[,2]),as.numeric(gsa.test.cumsum[,2]),as.numeric(mgsz.test.cumsum[,2]))
        
        
       colnames(data_split3) <- c("romer","GAGE","QuSAGE","wKS","CAMERA","Allez","mGSA","mGSZm")
    

cumulative1 <- apply(data_split1,2,cumsum)
cumulative2 <- apply(data_split2,2,cumsum)
cumulative3 <- apply(data_split3,2,cumsum)
cumulative <- (cumulative1 + cumulative2 + cumulative3)/3

        listOfCumSum[[i]] <- cumulative
        
    }
    return(listOfCumSum)
}

##################
