## Pashupati Mishra
## Liisa Holm's Bioinformatics lab
## Institute of Biotechnology, University of Helsinki
## 28.06.2016

AvgPermCumsumPlotPrimary <- function(listOfCumSum){

### R code for averaging the cumulative sum data from each of the data splits and plotting the average cumulative sum data for evaluation of the permutation methods 


cumsum.dat <- do.call(cbind,listOfCumSum)
cumsum.dat <- array(cumsum.dat, dim=c(dim(listOfCumSum[[1]]),length(listOfCumSum)))
avg.cumsum.dat <- apply(cumsum.dat,c(1,2),mean)
colnames(avg.cumsum.dat) <- colnames(listOfCumSum[[1]])
cumsumPlot(avg.cumsum.dat)

}

### R function to do cumulative sum plot ###

cumsumPlot <- function(data,cex_val=1,lwd_val=2,legend="up"){
    color_pal <- c("magenta","brown","darkgoldenrod","darkcyan","red","black")
    line_types <- 1:10
    point_types <- 1:7
    color_pal <- rep(color_pal, 4)
    line_types <- rep(line_types, 4)
    point_types <- rep(point_types, 4)
    #ylimits <- c(0,max(colSums(data)+1))
    ylimits <- c(0,20)
    dat_sz <- dim(data)
    point_inds <- round(seq(1,dat_sz[1], dat_sz[1]/30))
    
    for(i in 1:ncol(data)){
        if(i ==1){
            plot(data[,i], type="l",col=color_pal[i],lty=line_types[i],ylim=ylimits,lwd=lwd_val, cex=cex_val, ylab="Cumulative count of reference gene sets",xlab="Top 50 gene sets from test data")
        }
        else{
            lines(data[,i],col=color_pal[i],lty=line_types[i],lwd=lwd_val, cex=cex_val)
        }
        dat <- data[,i]
        dat[point_inds] <- -10
        points(dat, col = color_pal[i], pch = point_types[i], cex = cex_val, lwd = lwd_val)
    }
    
    if(legend == "up"){
        legend("topleft", colnames(data),lty = line_types[1:dat_sz[2]],
        col = color_pal[1:dat_sz[2]], pch = point_types[1:dat_sz[2]], cex = 1.5,lwd = lwd_val )
    }
    else{
        legend("bottomright", colnames(data),lty = line_types[1:dat_sz[2]],
        col = color_pal[1:dat_sz[2]], pch = point_types[1:dat_sz[2]], cex = cex_val,lwd = lwd_val )
    }
}

###############