## mGSZm wrapper
## Pashupati Mishra
## Liisa Holm's Bioinformatics lab
## Institute of Biotechnology, University of Helsinki
## 28.06.2016

mGSZH_final_emp <- function(expr.data,gene.sets,sample.labels,comparisons, method,other.methods=TRUE, min.cl.sz=1,max.cl.sz=5000, pre.var=0,wgt1=0.2,wgt2=0.5,var.constant=10,perm.number=200){


    start.val=5
  

   ########################################
   ## Testing that data sizes are correct #
   ########################################
   require(ismev)
   require(MASS)
    
    if(length(unique(sample.labels))==2){
        result <- mGSZ(expr.data=expr.data,gene.sets=gene.sets,sample.labels=sample.labels,perm.number=perm.number,other.methods=other.methods)
    }
    else{

   gene.sets <- toMatrix(expr.data,gene.sets)
   expr.dat.sz <- length(unique(rownames(expr.data)))
   num.genes <- length(unique(rownames(gene.sets)))
   
    ##Remove rows with no gene set members 
    
	data <- rm.rows.with.noSetMembers(expr.data,gene.sets)
	gene.sets <- data$gene.sets
    expr.data <- data$expr.data
    
    
     
   ##Remove too small gene sets
    
    gene.sets <- filter.genesets(gene.sets,min.cl.sz, max.cl.sz)
    geneset.classes <- colnames(gene.sets)
    num.classes <- ncol(gene.sets)
    geneset.class.sizes <- colSums(gene.sets)
    
    
   ##Calculation of gene scores

    if(method=="m1_limma"){
        print("m1_limma")
        tmp.expr.data = diffScoreMult1_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
        
    if(method=="m1_fc"){
        print("m1_fc")
        tmp.expr.data = diffScoreMult1_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
    
    if(method=="m1_wad"){
        print("m1_wad")
        tmp.expr.data = diffScoreMult1_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
        
    if(method=="m1_ad"){
        print("m1_ad")
        tmp.expr.data = diffScoreMult1_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
        
    if(method=="m1_cyberT"){
        print("m1_cyberT")
        tmp.expr.data = diffScoreMult1_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
        
    if(method=="m1_fcros"){
        print("m1_fcros")
        tmp.expr.data = diffScoreMult1_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
   ##################################################################################     
    
    if(method=="m2_limma"){
    print("m2_limma")
        tmp.expr.data = diffScoreMult2_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
    
    if(method=="m2_fc"){
    print("m2_fc")
        tmp.expr.data = diffScoreMult2_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m2_ad"){
    print("m2_ad")
        tmp.expr.data = diffScoreMult2_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m2_wad"){
    print("m2_wad")
        tmp.expr.data = diffScoreMult2_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m2_fcros"){
    print("m2_fcros")
        tmp.expr.data = diffScoreMult2_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m2_cyberT"){
    print("m2_cyberT")
        tmp.expr.data = diffScoreMult2_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
   ##################################################################################     
        
    
    if(method=="m3_limma"){
        print("m3_limma")
        tmp.expr.data = diffScoreMult3_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
        
    }
        
        
    if(method=="m3_fc"){
        print("m3_fc")
        tmp.expr.data = diffScoreMult3_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
        
        
    if(method=="m3_ad"){
        print("m3_ad")
        tmp.expr.data = diffScoreMult3_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
        
        
    if(method=="m3_wad"){
        print("m3_wad")
        tmp.expr.data = diffScoreMult3_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
        
        
    if(method=="m3_fcros"){
        print("m3_fcros")
        tmp.expr.data = diffScoreMult3_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
        
    
    if(method=="m3_cyberT"){
        print("m3_cyberT")
        tmp.expr.data = diffScoreMult3_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
        
    ###########################################################################    
        
      
        
    if(method=="m4_limma"){
        print("m4_limma")
        tmp.expr.data = diffScoreMult4_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m4_fc"){
        print("m4_fc")
        tmp.expr.data = diffScoreMult4_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
        
    if(method=="m4_ad"){
        print("m4_ad")
        tmp.expr.data = diffScoreMult4_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m4_wad"){
        print("m4_wad")
        tmp.expr.data = diffScoreMult4_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m4_fcros"){
        print("m4_fcros")
        tmp.expr.data = diffScoreMult4_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m4_cyberT"){
        print("m4_cyberT")
        tmp.expr.data = diffScoreMult4_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    ###########################################################################
    
    
    if(method=="m33_limma"){
    print("m33_limma")
        tmp.expr.data = diffScoreMult33_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    if(method=="m33_wad"){
    ## before "method = 333" ###
    print("m33_wad")
        tmp.expr.data = diffScoreMult33_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    
    if(method=="m33_fc"){
    print("m33_fc")
        tmp.expr.data = diffScoreMult33_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    
    if(method=="m33_ad"){
    print("m33_ad")
        tmp.expr.data = diffScoreMult33_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    
    if(method=="m33_fcros"){
    print("m33_fcros")
        tmp.expr.data = diffScoreMult33_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    
    if(method=="m33_cyberT"){
    print("m33_cyberT")
        tmp.expr.data = diffScoreMult33_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
            
    }
    
    
    
    ###########################################################################
    
    
        
    if(method=="m44_limma"){
    print("m44_limma")
            tmp.expr.data = diffScoreMult44_limma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
        
    if(method=="m44_wad"){
    
    ## before, m=4444 ##
        print("m44_wad")
            tmp.expr.data = diffScoreMult44_wad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m44_ad"){
    print("m44_ad")
            tmp.expr.data = diffScoreMult44_ad(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m44_fc"){
    print("m44_fc")
            tmp.expr.data = diffScoreMult44_fc(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    if(method=="m44_fcros"){
    print("m44_fcros")
            tmp.expr.data = diffScoreMult44_fcros(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method=="m44_cyberT"){
    print("m44_cyberT")
            tmp.expr.data = diffScoreMult44_cyberT(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    ##############################################################################
    ########################### not very important ones ##########################
    
    if(method==5){
        print("QD3")
        tmp.expr.data = diffScoreMult3_QD(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method==6){
        print("QD1")
        tmp.expr.data = diffScoreMult1_QD(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method==7){
        print("mlimma")
        tmp.expr.data = diffScoreMult3_mlimma(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    if(method==9){
        print("std_tscore")
        tmp.expr.data = diffScoreMult3_tscore(expr.data, gene.sets, labels=sample.labels, comparisons=comparisons, perm.number)
    }
    
    
    diff.expr.dat.sz <- dim(tmp.expr.data[[1]])
    
    
    
    
    num.genes <- nrow(tmp.expr.data[[1]]) ##thapeko (not useful as gsz code calculates itself)
    
	#lls()
	## mGSZ score for positive data ####
	
    pos.gsz <- list()
    pos.gsa <- list()
    pos.allez <- list()
    
    if(other.methods==TRUE){
        pos.ss <- list()
        pos.sum <- list()
        pos.wks <- list()
    }
    
    
    for(i in 1:length(comparisons)){
        res <- mGSZ.test.score22(expr.data=tmp.expr.data[[i]][,1], gene.sets, wgt1, wgt2, pre.var, var.constant, start.val)
        pos.gsz[[i]] <- res$gene.set.scores$mGSZ.scores
        pos.gsa[[i]] <- res$gene.set.scores$mGSA.scores
        pos.allez[[i]] <- res$gene.set.scores$mAllez.scores
        
        if(other.methods==TRUE){
            pos.ss[[i]] <- SS.test.score(expr.data=tmp.expr.data[[i]][,1], gene.sets)
            pos.sum[[i]] <- sumTestscore(expr.data=tmp.expr.data[[i]][,1], gene.sets)
            pos.wks[[i]] <- KS.score(expr.data=tmp.expr.data[[i]][,1], gene.sets)$KS.mod
        }
    }
    names(pos.gsz) <- comparisons
    names(pos.gsa) <- comparisons
    names(pos.allez) <- comparisons

    
    if(other.methods==TRUE){
        names(pos.ss) <- comparisons
        names(pos.sum) <- comparisons
        names(pos.wks) <- comparisons
    }
  
    
	 ## mGSZ for sample permutation data ###
	
	col.perm.gsz <- list()
    col.perm.gsa <- list()
    col.perm.allez <- list()
    
    if(other.methods==TRUE){
        col.perm.ss <- list()
        col.perm.sum <- list()
        col.perm.wks <- list()
    }
    
    
    for(j in 1:length(comparisons)){
        
        col.perm.gsz[[j]] <- matrix(0, perm.number, num.classes)
        col.perm.gsa[[j]] <- matrix(0, perm.number, num.classes)
        col.perm.allez[[j]] <- matrix(0, perm.number, num.classes)
        
        if(other.methods==TRUE){
            col.perm.ss[[j]] <- matrix(0, perm.number, num.classes)
            col.perm.sum[[j]] <- matrix(0, perm.number, num.classes)
            col.perm.wks[[j]] <- matrix(0, perm.number, num.classes)
        }
    }

	
    for(l in 1:length(comparisons)){
        for( k in 1:perm.number){
            res <- mGSZ.test.score22(tmp.expr.data[[l]][,1+k], gene.sets,wgt1, wgt2, pre.var, var.constant, start.val)
            col.perm.gsz[[l]][k,] <- as.numeric(res$gene.set.scores$mGSZ.score)
            col.perm.gsa[[l]][k,] <- as.numeric(res$gene.set.scores$mGSA.score)
            col.perm.allez[[l]][k,] <- as.numeric(res$gene.set.scores$mAllez.score)
            
            if(other.methods==TRUE){
                col.perm.ss[[l]][k,] <- SS.test.score(tmp.expr.data[[l]][,1+k], gene.sets)
                col.perm.sum[[l]][k,] <- sumTestscore(tmp.expr.data[[l]][,1+k], gene.sets)
                col.perm.wks[[l]][k,] <- KS.score(tmp.expr.data[[l]][,1+k], gene.sets)$KS.mod
            }

        }
    }
     
     


### p-value calculation for the gene set scores with sample permutation ###
    pvals.gsz <- list()
    pvals.gsa <- list()
    pvals.allez <- list()
    
    if(other.methods==TRUE){
        pvals.ss <- list()
        pvals.sum <- list()
        pvals.wks <- list()
    }
    for(l in 1:length(comparisons)){
        
        pvals.gsz[[l]] <- mGSZ.p.values(pos.gsz[[l]],col.perm.gsz[[l]]) ## not empirical p-value
        #pvals.gsz[[l]] <- GSZ.p.values(pos.gsz[[l]],col.perm.gsz[[l]]) ## empirical p-value
        pvals.gsa[[l]] <- GSZ.p.values(pos.gsa[[l]],col.perm.gsa[[l]]) ## empirical p-value
        pvals.allez[[l]] <- mAllez.p.values(pos.allez[[l]],col.perm.allez[[l]])

        
        if(other.methods==TRUE){
            pvals.ss[[l]] <- SS.p.values(pos.ss[[l]], col.perm.ss[[l]])
            pvals.sum[[l]] <- mAllez.p.values(pos.sum[[l]], col.perm.sum[[l]])
            pvals.wks[[l]] <- KS.p.values(pos.wks[[l]], col.perm.wks[[l]])
            
        }
   
    }
    
    names(pvals.gsz) <- names(pos.gsz)
    names(pvals.gsa) <- names(pos.gsa)
    names(pvals.allez) <- names(pos.allez)
    if(other.methods==TRUE){
        names(pvals.ss) <- names(pos.ss)
        names(pvals.sum) <- names(pos.sum)
        names(pvals.wks) <- names(pos.wks)
    }
    
    
    if(length(unique(rownames(expr.data)))<length(rownames(expr.data))){
        expdat <- aggregate(expr.data,by=list(rownames(expr.data)),FUN=mean)
        rownames(expdat) <- expdat[,1]
        expdat <- expdat[,2:dim(expdat)[2]] }
    else{expdat <- expr.data}

    ind <- match(rownames(tmp.expr.data[[1]]),rownames(expdat))
    expdat <- expdat[ind,]
    out1 <- expdat
    out2 <- gene.sets
    fc_scores <- gene_sets_fc_score(expdat, comparisons, sample.labels, gene.sets)
    
    ##Output table for each of the methods

    result <- list()
    for(a in 1:length(comparisons)){
        table.gsz <- data.frame(gene.sets = colnames(gene.sets)[pvals.gsz[[a]][[2]]], set.size = geneset.class.sizes[pvals.gsz[[a]][[2]]], Scores = pos.gsz[[a]][pvals.gsz[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.gsz[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.gsz[[a]][[2]]], Pvalue = pvals.gsz[[a]][[1]],row.names=NULL)
        
        #table.gsz <- table.gsz[order(table.gsz[,6]),]
        
        table.gsa <- data.frame(gene.sets = colnames(gene.sets)[pvals.gsa[[a]][[2]]], set.size = geneset.class.sizes[pvals.gsa[[a]][[2]]], Scores = pos.gsa[[a]][pvals.gsa[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.gsa[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.gsa[[a]][[2]]], Pvalue = pvals.gsa[[a]][[1]],row.names=NULL)
        
        #table.gsa <- table.gsa[order(table.gsa[,6])]
        
        table.allez <- data.frame(gene.sets = colnames(gene.sets)[pvals.allez[[a]][[2]]], set.size = geneset.class.sizes[pvals.allez[[a]][[2]]], Scores = pos.allez[[a]][pvals.allez[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.allez[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.allez[[a]][[2]]], Pvalue = pvals.allez[[a]][[1]],row.names=NULL)
        
        #table.allez <- table.allez[order(table.allez[,6])]
        
        if(other.methods==TRUE){
            
            table.ss <- data.frame(gene.sets = colnames(gene.sets)[pvals.ss[[a]][[2]]], set.size = geneset.class.sizes[pvals.ss[[a]][[2]]], Scores = pos.ss[[a]][pvals.ss[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.ss[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.ss[[a]][[2]]], Pvalue = pvals.ss[[a]][[1]],row.names=NULL)
            
            # table.ss <- table.ss[order(table.ss[,6]),]
            
            table.sum <- data.frame(gene.sets = colnames(gene.sets)[pvals.sum[[a]][[2]]], set.size = geneset.class.sizes[pvals.sum[[a]][[2]]], Scores = pos.sum[[a]][pvals.sum[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.sum[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.sum[[a]][[2]]], Pvalue = pvals.sum[[a]][[1]],row.names=NULL)
            
            #table.sum <- table.sum[order(table.sum[,6])]
            
            table.wks <- data.frame(gene.sets = colnames(gene.sets)[pvals.wks[[a]][[2]]], set.size = geneset.class.sizes[pvals.wks[[a]][[2]]], Scores = pos.wks[[a]][pvals.wks[[a]][[2]]],FC = fc_scores[[a]][[2]][pvals.wks[[a]][[2]]], abs_FC = fc_scores[[a]][[1]][pvals.wks[[a]][[2]]], Pvalue = pvals.wks[[a]][[1]],row.names=NULL)
            
            #table.wks <- table.wks[order(table.wks[,6]),]
        }
        
        
        result[[a]] <- list(mGSZH = table.gsz, mGSAH = table.gsa, mAllezM = table.allez, sample.labels = sample.labels, perm.number = perm.number, expr.data = expr.data, gene.sets = gene.sets, min.cl.sz = min.cl.sz, pre.var = pre.var, wgt2 = wgt2, wgt1 = wgt1, var.constant = var.constant, start.val = start.val,comparison=comparisons[a])
        
        if(other.methods==TRUE){
            result[[a]] <- list(mGSZH = table.gsz, mGSAH = table.gsa, mAllezM = table.allez, SSM = table.ss, SUMM = table.sum, wksM = table.wks, sample.labels = sample.labels, perm.number = perm.number, expr.data = expr.data, tmp.expr.data=tmp.expr.data[[a]], gene.sets = gene.sets, min.cl.sz = min.cl.sz, pre.var = pre.var, wgt2 = wgt2, wgt1 = wgt1, var.constant = var.constant, start.val = start.val,comparison=comparisons[a])
        }
    
    }
    names(result) <- paste("comparison",c(1:length(result)),sep="")
    }
    return(result)
}


#####################

### calculation of fold change of member genes ###
gene_sets_fc_score <- function(expr.data, comparisons, sample.labels, gene.sets){
  fc <- list()
  for(j in 1:length(comparisons)){
    grps <- getNumeric(comparisons[j])
    ind <- match(sample.labels,grps)
    ind.na <- which(is.na(ind))
    expr <- expr.data[,-ind.na]
    labels <- sample.labels[-ind.na]
    fc[[j]] <- expr.fc(expr, labels, gene.sets)
  }
  return(fc)
}

## R code to calculate mean fold change/absolute fold change of expression of member genes
expr.fc <- function(expr, labels, gene.sets){
  #expr.data: Subset of expr.data for a particular comparisons
  fc <- rep(NA,ncol(gene.sets))
  abs.fc <- fc
  grp1 <- table(labels)[[1]]
  grp2 <- table(labels)[[2]]
  for(i in 1:ncol(gene.sets)){
     ind <- which(gene.sets[,i]==1)
     exprdat <- expr[ind,]
     fc[i] <- -mean(apply(exprdat[,1:grp1],1,mean)-apply(exprdat[,(grp1+1):(grp1+grp2)],1,mean))
     abs.fc[i] <- mean(abs(apply(exprdat[,1:grp1],1,mean)-apply(exprdat[,(grp1+1):(grp1+grp2)],1,mean)))
     }
  out <- list(abs.fc=abs.fc,fc=fc)
  return(out)
}

### R code to get numeric part from a string ###
getNumeric <- function(string){
  str <- strsplit(string,"[^[:digit:]]")
  res <- as.numeric(unlist(str))
  sol <- res[!is.na(res)]
  return(sol)
}
#####################
###############
toTable <- function(mGSZMobj,comparisons){
    out <- mGSZMobj[[comparisons]]
    out <- out[order(out[,4],decreasing=F),]
    out
}

################

rm.rows.with.noSetMembers <-
function(expr.data,gene.sets){
	tmp_sum <- apply(gene.sets, 1, sum)
    ind_wth_sets <- which(tmp_sum > 0)
    expr.data <- expr.data[ind_wth_sets,]
    gene.sets   <- gene.sets[ind_wth_sets,]
    out <- list(expr.data=expr.data, gene.sets=gene.sets)}
    
###############
## removes too small and too big gene sets ##
filter.genesets <-
function(gene.sets,min.cl.sz, max.cl.sz){
    tmp_sum <- apply(gene.sets, 2, sum)
    ind_wth_sets <- which(tmp_sum > min.cl.sz & tmp_sum < max.cl.sz)
    gene.sets   <- gene.sets[,ind_wth_sets]
	out=gene.sets}

##################

sumVarMean_calc <-
function(expr_data, gene.sets, pre.var){
	dim_sets <- dim(gene.sets)
	length_expr <- length(expr_data)
	set_sz <- colSums(gene.sets)

	unique_class_sz <- unique(set_sz)
	num_genes <- length(expr_data)
	
	divider <- c(1:num_genes)
    mean_table <- cumsum(expr_data)/divider
    mean_table_sq <- mean_table^2
    var_table <- cumsum(expr_data^2)/divider - (mean_table)^2 + pre.var
    class_sz_index <- rep(0,dim_sets[2])
    for (i in 1:dim_sets[2]){
    	class_sz_index[i] <- which(set_sz[i]==unique_class_sz)
    }
    var_table <- var_table + pre.var
    hyge_stat <- count_hyge_var_mean(dim_sets[1],unique_class_sz)
    
    z_var <- matrix(numeric(0),dim_sets[1],length(unique_class_sz)) 
    
    z_mean <- z_var
    max_value <- 1:dim_sets[1]
    for (j in 1:length(unique_class_sz)){
    	prob_sum <- count.prob.sum(dim_sets[1],hyge_stat$mean[,j],hyge_stat$var[,j])
    	z_var[,j] <- 4*(var_table*prob_sum + mean_table_sq*hyge_stat$var[,j])
    	z_mean[,j] <- mean_table*(2*hyge_stat$mean[,j]-max_value)}
        
        out = list(Z_var = z_var, Z_mean = z_mean, class_size_index = class_sz_index,var_table=var_table,mean_table_sq=mean_table_sq,set_sz=set_sz)
        return(out)
  
    
}

#########

count.prob.sum <-
function(M, hyge.mean, hyge.var){
    tulos = matrix(rep(0,length(hyge.mean)),byrow=FALSE)
    N_tab = matrix(c(2:M),byrow=FALSE)
    tulos[1] = hyge.mean[1]
    tulos[2:M] = N_tab/(N_tab-1)*hyge.mean[2:M]-(hyge.mean[2:M]^2+hyge.var[2:M])/(N_tab-1)
    tulos = tulos
}

############

count_hyge_var_mean <-
function(M,K){
    N = matrix(rep((1:M),length(K)),ncol=length(K))
    K = matrix(rep(K,M),byrow=TRUE,ncol=length(K))
    out1 = N*K/M
    out2 = N*(K*(M-K)/M^2)*((M-N)/(M-1))
    results = list(mean= out1, var= out2)
}

##############

calc_z_var <-
function(num.genes,unique_class_sz_ln,pre_z_var,wgt2,var.constant){
	ones_matrix = matrix(1,num.genes,unique_class_sz_ln)
	ones_tmatrix = t(ones_matrix)
	median_matrix = apply(pre_z_var,2,median)
	pre_median_part = ones_tmatrix*median_matrix*wgt2
	median_part = t(pre_median_part)
	z_var = (pre_z_var + median_part + var.constant)^0.5
}

#############

geneSetsList <-
function(data){
  data <- GSA.read.gmt(data)
  geneSets <- data$genesets
  names(geneSets) <- data$geneset.names
  return(geneSets)
}


##############
diffScoreMult3_limma <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F) ##this has to be improved
            }
            else{
            grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
            x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
    perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
        
        
        ## calculation of t-scores for original data ##########
    
        org.tscores <- list()
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        mySet <- new("ExpressionSet",expr=as.matrix(expr))
        fit1 <- lmFit(mySet, design)
        cont.matrix <- makeContrasts(contrasts=comparisons,levels=design)
        fit2 <- contrasts.fit(fit1, cont.matrix)
        fit2 <- eBayes(fit2)
        for(i in 1:length(comparisons)){
            org.tscores[[i]] <- fit2$t[,i]
        }
    
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.tscores <- vector("list",perm.number)
        for(k in 1:perm.number){
            perm.t <- list()
            design <- perm.designs[[k]]
            colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            mySet <- new("ExpressionSet",expr=as.matrix(expr))
            fit1 <- lmFit(mySet, design)
            cont.matrix <- makeContrasts(contrasts=comparisons,levels=design)
            fit2 <- contrasts.fit(fit1, cont.matrix)
            fit2 <- eBayes(fit2)
            for(i in 1:length(comparisons)){
                perm.t[[i]] <- fit2$t[,i]
            }
            perm.tscores[[k]] <- perm.t
        }
    
        tscores.tot <- list()
        for(i in 1:length(comparisons)){
            tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
        }
    
        for(j in 1:length(comparisons)){
            for(k in 1:perm.number){
                tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
            }
        }
    
        for(i in 1:length(comparisons)){
            tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
        }
    
    # for(z in 1:length(comparisons)){
    #    rownames(tscores.tot[[z]]) <- rownames(expr.data)
    #    if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
    #       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
    #       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
    #       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            #tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    #   }
        
    #   ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
    #   tscores.tot[[z]] <- tscores.tot[[z]][ind,]

        
        
    #out <- tscores.tot
            
    #}
return(tscores.tot)
}


######################################################################


##################

diffScoreMult3_fc <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- FC(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- FC(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}





#######################################################################

diffScoreMult4_limma <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    mySet <- new("ExpressionSet",expr=as.matrix(expr))
    fit1 <- lmFit(mySet, design)
    cont.matrix <- makeContrasts(contrasts=comparisons,levels=design)
    fit2 <- contrasts.fit(fit1, cont.matrix)
    fit2 <- eBayes(fit2)
    for(i in 1:length(comparisons)){
        org.tscores[[i]] <- fit2$t[,i]
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        mySet <- new("ExpressionSet",expr=as.matrix(expr))
        fit1 <- lmFit(mySet, design)
        cont.matrix <- makeContrasts(contrasts=comparisons,levels=design)
        fit2 <- contrasts.fit(fit1, cont.matrix)
        fit2 <- eBayes(fit2)
        for(i in 1:length(comparisons)){
            perm.t[[i]] <- fit2$t[,i]
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}


#######################################################################

diffScoreMult4_fc <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    
    for(i in 1:length(comparisons)){
    
        Grps <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(design[,Grps[1]]==1))
        ind2 <- as.numeric(which(design[,Grps[2]]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- FC(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        
        for(i in 1:length(comparisons)){
            
            Grps <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(design[,Grps[1]]==1))
            ind2 <- as.numeric(which(design[,Grps[2]]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- FC(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}


#######################################################################

diffScoreMult4_ad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    
    for(i in 1:length(comparisons)){
    
        Grps <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(design[,Grps[1]]==1))
        ind2 <- as.numeric(which(design[,Grps[2]]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- AD(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        
        for(i in 1:length(comparisons)){
            
            Grps <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(design[,Grps[1]]==1))
            ind2 <- as.numeric(which(design[,Grps[2]]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- AD(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}

#######################################################################

diffScoreMult4_wad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    
    for(i in 1:length(comparisons)){
    
        Grps <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(design[,Grps[1]]==1))
        ind2 <- as.numeric(which(design[,Grps[2]]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- WAD(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        
        for(i in 1:length(comparisons)){
            
            Grps <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(design[,Grps[1]]==1))
            ind2 <- as.numeric(which(design[,Grps[2]]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- WAD(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}

#######################################################################

diffScoreMult4_fcros <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    
    for(i in 1:length(comparisons)){
    
        Grps <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(design[,Grps[1]]==1))
        ind2 <- as.numeric(which(design[,Grps[2]]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        cont <- colnames(exprdat)[1:length(ind1)]
        test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        log2.opt <- 0
        trim.opt <- 0.2
        org.tscores[[i]] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        
        for(i in 1:length(comparisons)){
            
            Grps <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(design[,Grps[1]]==1))
            ind2 <- as.numeric(which(design[,Grps[2]]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            cont <- colnames(exprdat)[1:length(ind1)]
            test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            log2.opt <- 0
            trim.opt <- 0.2
            perm.t[[i]] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}

#######################################################################

diffScoreMult4_cyberT <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        for(i in 1:length(lbs.org)){
                nonEmptyGrps <- sum(lapply(lbs.ite,function(x) length(x))!=0)
                if(nonEmptyGrps>=length(lbs.org[[i]])){
                    lst[[i]] <- c(resamp(unlist(lapply(lbs.ite,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[i]]),replace=F))}
                else{
                    lst[[i]] <- resamp(unlist(lbs.ite),length(lbs.org[[i]]),replace=F)}
                lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    ###### calculation of t-scores for original data ##########
    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    
    for(i in 1:length(comparisons)){
    
        Grps <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(design[,Grps[1]]==1))
        ind2 <- as.numeric(which(design[,Grps[2]]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        
        org.tscores[[i]] <- as.numeric(res[,ind])
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        design <- perm.designs[[k]]
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        
        for(i in 1:length(comparisons)){
            
            Grps <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(design[,Grps[1]]==1))
            ind2 <- as.numeric(which(design[,Grps[2]]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
            ind <- grep("bayesT",colnames(res))
            perm.t[[i]] <- as.numeric(res[,ind])
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
       rownames(tscores.tot[[z]]) <- rownames(expr.data)
       tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
       rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
       tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]] 
       tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
    }

    return(tscores.tot)
    
}



#########

diffScoreMult33_limma <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            # if(sig_leakage==0){
            #print("Signal leakage probability = 0%")
                rel_grps <- lbs.org[ind]
        
                trans <- updateLbs(rel_grps,g1)
                g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
                g1 <- c(g1,pg1[1])
                g2 <- c(g2,pg1[2])
            
            
                g1 <- c(g1,pg2[1])
                g2 <- c(g2,pg2[2])
            
            
                grp1[j,] <- g1
                grp2[j,] <- g2
            # }
            
            #if(sig_leakage==0.25){
            #print("Signal leakage probability = 25%")
            
            #   indd <- sample((1:length(lbs.org))[-ind],((1:length(lbs.org))[-ind]/2),replace=F)
            #   rel_grps <- lbs.org[c(ind,indd)]
        
            #   trans <- updateLbs(rel_grps,g1)
            #   g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            #   g1 <- c(g1,pg1[1])
            #   g2 <- c(g2,pg1[2])
            
            
            #   g1 <- c(g1,pg2[1])
            #   g2 <- c(g2,pg2[2])
            
            
            #   grp1[j,] <- g1
            #   grp2[j,] <- g2
            
            #}
            
            # if(sig_leakage==0.50){
            #print("Signal leakage probability = 50%") ##not working
            
            #   indd <- sample((1:length(lbs.org))[-ind],((1:length(lbs.org))[-ind]),replace=F)
            #   rel_grps <- lbs.org[c(ind,indd)]
        
            #   trans <- updateLbs(rel_grps,g1)
            #   g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            #   g1 <- c(g1,pg1[1])
            #   g2 <- c(g2,pg1[2])
            
            
            #   g1 <- c(g1,pg2[1])
            #   g2 <- c(g2,pg2[2])
            
            
            #   grp1[j,] <- g1
            #   grp2[j,] <- g2
            
            
            #}
        }
        
    
        ###### calculation of t-scores for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        mySet <- new("ExpressionSet",expr=as.matrix(expr))
        fit1 <- lmFit(mySet, design)
        cont.matrix <- makeContrasts(contrasts=comparisons[c],levels=design)
        fit2 <- contrasts.fit(fit1, cont.matrix)
        fit2 <- eBayes(fit2)
        org.tscores <- fit2$t
        
    
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            mySet <- new("ExpressionSet",expr=as.matrix(expr))
            fit1 <- lmFit(mySet, des)
            cont.matrix <- makeContrasts(contrasts=comparisons[c],levels=des)
            fit2 <- contrasts.fit(fit1, cont.matrix)
            fit2 <- eBayes(fit2)
            perm.t[,k] <- fit2$t
        }
    out <- cbind(org.tscores,perm.t)
    rownames(out) <- rownames(expr.data)
    total[[c]] <- out
    }
    
return(total)

    
}

#########

diffScoreMult33_wad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number,sig_leakage){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            g1 <- c(g1,pg1[1])
            g2 <- c(g2,pg1[2])
            
            
            g1 <- c(g1,pg2[1])
            g2 <- c(g2,pg2[2])
            
            
            grp1[j,] <- g1
            grp2[j,] <- g2
            }
        
    
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- WAD(exprdat,data.cl)
        
        ###########
        
        
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- WAD(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
    
}

################################################################

diffScoreMult33_ad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number,sig_leakage){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            g1 <- c(g1,pg1[1])
            g2 <- c(g2,pg1[2])
            
            
            g1 <- c(g1,pg2[1])
            g2 <- c(g2,pg2[2])
            
            
            grp1[j,] <- g1
            grp2[j,] <- g2
            }
        
    
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- AD(exprdat,data.cl)
        
        ###########
        
        
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- AD(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
    
}


############################################################################

diffScoreMult33_fc <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number,sig_leakage){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            g1 <- c(g1,pg1[1])
            g2 <- c(g2,pg1[2])
            
            
            g1 <- c(g1,pg2[1])
            g2 <- c(g2,pg2[2])
            
            
            grp1[j,] <- g1
            grp2[j,] <- g2
            }
        
    
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- FC(exprdat,data.cl)
        
        ###########
        
        
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- FC(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
    
}

#######################################################################


diffScoreMult33_cyberT <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number,sig_leakage){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            g1 <- c(g1,pg1[1])
            g2 <- c(g2,pg1[2])
            
            
            g1 <- c(g1,pg2[1])
            g2 <- c(g2,pg2[2])
            
            
            grp1[j,] <- g1
            grp2[j,] <- g2
            }
        
    
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        
        res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        org.tscores <- as.numeric(res[,ind])
        
        ###########
        
        
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            
            res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
            ind <- grep("bayesT",colnames(res))
            perm.t[,k] <- as.numeric(res[,ind])
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
    
}


#######################################################################


diffScoreMult33_fcros <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number,sig_leakage){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))

        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            
            ## the compared grps must also contribute to permutations##
            pg1 <- sample(lbs.org[[grps[1]]],2,replace=FALSE)
            pg2 <- sample(lbs.org[[grps[2]]],2,replace=FALSE)
            lbs.org <- lbs.org[-c(grps[1],grps[2])]
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[1]]])-2),replace=F))
            ind <- findInterval(match(g1, unlist(lbs.org)), cumsum(c(0,sapply(lbs.org, length)))+1)
            
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),(length(lbs[[grps[2]]])-2),replace=F))
            g1 <- c(g1,pg1[1])
            g2 <- c(g2,pg1[2])
            
            
            g1 <- c(g1,pg2[1])
            g2 <- c(g2,pg2[2])
            
            
            grp1[j,] <- g1
            grp2[j,] <- g2
            }
        
    
        
        
        ###### calculation of fcros for original data ##########
        
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        rownames(exprdat) <- rownames(expr.data)
        
        cont <- colnames(exprdat)[1:length(ind1)]
        test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        
        log2.opt <- 0
        trim.opt <- 0.2
        
        
        org.tscores <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        
        ###########
        
        
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            rownames(exprdat) <- rownames(expr.data)
            
            cont <- colnames(exprdat)[1:length(ind1)]
            test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            
            log2.opt <- 0
            trim.opt <- 0.2

            perm.t[,k] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
    
}



############################ subfunctions #############################

## function for sampling ##
resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}

##function to update sample labels ##
updateLbs <- function(lbs,ind){
    l <- unlist(lbs)[-which(unlist(lbs)%in%ind)]
    lb <- list()
    for(i in 1:length(lbs)){
        lb[[i]] <- lbs[[i]][which(lbs[[i]]%in%l)]
    }
    lb
}


######################
## function to create design matrix for permuted data ##
getPointers <- function(perms,labels){
    ngroups <- length(unique(labels))
    perm.labels <- list()
    d <- matrix(0,length(labels),ngroups)
    for(k in 1:length(perms)){
        for(i in 1:ngroups){
            n <- rep(0,length(labels))
            n[perms[[k]][[i]]] <- 1
            d[,i] <- n
        }
        perm.labels[[k]] <- d
    }
    return(perm.labels)
}



######################

### t-score calculation based on the first option ###
diffScoreMult1_limma <- function(expr.data, gene.sets, labels, comparisons, perm.number){
  require(limma)
  require(Biobase)
  expr <- expr.data
  rownames(expr) <- NULL
  m <- gregexpr("[0-9]+",comparisons)
  CompGroups <- regmatches(comparisons,m)
  dime2 <- dim(expr)
  tscores.tot <- list()
  FC.tot <- tscores.tot
  #dime <- list()

  for(i in 1:length(CompGroups)){
    ## pit is length of compared groups combined
    pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
    z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
    perms <- replicate(perm.number,sample(z,pit,replace=FALSE))

    dime <- dim(perms)
    tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
    FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
          
    ## Calculation of t-scores for original data for a particular comparison ##

    design <- model.matrix(~0 + factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    mySet <- new("ExpressionSet",expr=as.matrix(expr))
    fit1 <- lmFit(mySet, design)
    cont.matrix <- makeContrasts(contrasts=comparisons[i],levels=design)
    fit2 <- contrasts.fit(fit1, cont.matrix)
    fit2 <- eBayes(fit2)
    tscores.tot[[i]][,1] <- fit2$t

    ## Calculation of t-scores for permuted data for a particular comparison ##

    for(k in 1:dime[2]){
      ind <- which(labels %in% CompGroups[[i]])
      lb <- labels
      lb[ind] <- perms[,k]
      design <- model.matrix(~0+as.factor(lb))
      colnames(design) <- paste("group",c(1:length(levels(factor(lb)))),sep="")
      fit1 <- lmFit(mySet, design)
      cont.matrix <- makeContrasts(contrasts=comparisons[i],levels=design)
      fit2 <- contrasts.fit(fit1, cont.matrix)
      fit2 <- eBayes(fit2)
      tscores.tot[[i]][,k+1] <- fit2$t
    }
    rownames(tscores.tot[[i]]) <- rownames(expr.data)
    if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
        tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
        rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
        tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[i]]))
        tscores.tot[[i]] <- tscores.tot[[i]][ind,]
        }
      
out <- tscores.tot
  
return(out)
  }
}

### fold change calculation based on the first option ###

diffScoreMult1_fc <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    FC.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
            
            ## Calculation of FC-scores for original data for a particular comparison ##
            ind1 <- which(labels==CompGroups[[i]][1])
            ind2 <- which(labels==CompGroups[[i]][2])
            expdat <- expr[,c(ind1,ind2)]
            lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            FC.tot[[i]][,1] <- FC(expdat,lbs)
            
            
            ## Calculation of FC-scores for permuted data for a particular comparison ##
            
            for(k in 1:dime[2]){
                ind <- which(labels %in% CompGroups[[i]])
                lb <- labels
                lb[ind] <- perms[,k]
                design <- model.matrix(~0+as.factor(lb))
                ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
                ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
                expdat <- expr[,c(ind1,ind2)]
                lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
                FC.tot[[i]][,k+1] <- FC(expdat,lbs)
            }
            
            rownames(FC.tot[[i]]) <- rownames(expr.data)
            if(length(unique(rownames(FC.tot[[i]])))<length(rownames(FC.tot[[i]]))){
                FC.tot[[i]] <- aggregate(FC.tot[[i]],by=list(rownames(FC.tot[[i]])),FUN=mean)
                rownames(FC.tot[[i]]) <- FC.tot[[i]][,1]
                FC.tot[[i]] <- FC.tot[[i]][,2:dim(FC.tot[[i]])[2]]
                ind <- match(rownames(gene.sets),rownames(FC.tot[[i]]))
                FC.tot[[i]] <- FC.tot[[i]][ind,]
            }
            
            out <- FC.tot
        
        
        return(out)
    }
}

######################

### weighted average distance calculation based on the first option ###

diffScoreMult1_wad <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    FC.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of FC-scores for original data for a particular comparison ##
        ind1 <- which(labels==CompGroups[[i]][1])
        ind2 <- which(labels==CompGroups[[i]][2])
        expdat <- expr[,c(ind1,ind2)]
        lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        FC.tot[[i]][,1] <- WAD(expdat,lbs)
        
        
        ## Calculation of FC-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- labels
            lb[ind] <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
            ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
            expdat <- expr[,c(ind1,ind2)]
            lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            FC.tot[[i]][,k+1] <- WAD(expdat,lbs)
        }
        
        rownames(FC.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(FC.tot[[i]])))<length(rownames(FC.tot[[i]]))){
            FC.tot[[i]] <- aggregate(FC.tot[[i]],by=list(rownames(FC.tot[[i]])),FUN=mean)
            rownames(FC.tot[[i]]) <- FC.tot[[i]][,1]
            FC.tot[[i]] <- FC.tot[[i]][,2:dim(FC.tot[[i]])[2]]
            ind <- match(rownames(gene.sets),rownames(FC.tot[[i]]))
            FC.tot[[i]] <- FC.tot[[i]][ind,]
        }
        
        out <- FC.tot
        
        
        return(out)
    }
}


### average distance calculation based on the first option ###

diffScoreMult1_ad <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    FC.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of FC-scores for original data for a particular comparison ##
        ind1 <- which(labels==CompGroups[[i]][1])
        ind2 <- which(labels==CompGroups[[i]][2])
        expdat <- expr[,c(ind1,ind2)]
        lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        FC.tot[[i]][,1] <- AD(expdat,lbs)
        
        
        ## Calculation of FC-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- labels
            lb[ind] <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
            ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
            expdat <- expr[,c(ind1,ind2)]
            lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            FC.tot[[i]][,k+1] <- AD(expdat,lbs)
        }
        
        rownames(FC.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(FC.tot[[i]])))<length(rownames(FC.tot[[i]]))){
            FC.tot[[i]] <- aggregate(FC.tot[[i]],by=list(rownames(FC.tot[[i]])),FUN=mean)
            rownames(FC.tot[[i]]) <- FC.tot[[i]][,1]
            FC.tot[[i]] <- FC.tot[[i]][,2:dim(FC.tot[[i]])[2]]
            ind <- match(rownames(gene.sets),rownames(FC.tot[[i]]))
            FC.tot[[i]] <- FC.tot[[i]][ind,]
        }
        
        out <- FC.tot
        
        
        return(out)
    }
}

### cyberT calculation based on the first option ###

diffScoreMult1_cyberT <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    FC.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of cyberT-scores for original data for a particular comparison ##
        ind1 <- which(labels==CompGroups[[i]][1])
        ind2 <- which(labels==CompGroups[[i]][2])
        expdat <- expr[,c(ind1,ind2)]
        
        res <- bayesT(expdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        FC.tot[[i]][,1] <- as.numeric(res[,ind])
        
        
        
        ## Calculation of cyberT-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- labels
            lb[ind] <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
            ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
            expdat <- expr[,c(ind1,ind2)]
            
            res <- bayesT(expdat,length(ind1),length(ind2),ppde=FALSE)
            ind <- grep("bayesT",colnames(res))
            FC.tot[[i]][,k+1] <- as.numeric(res[,ind])
        }
        
        rownames(FC.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(FC.tot[[i]])))<length(rownames(FC.tot[[i]]))){
            FC.tot[[i]] <- aggregate(FC.tot[[i]],by=list(rownames(FC.tot[[i]])),FUN=mean)
            rownames(FC.tot[[i]]) <- FC.tot[[i]][,1]
            FC.tot[[i]] <- FC.tot[[i]][,2:dim(FC.tot[[i]])[2]]
            ind <- match(rownames(gene.sets),rownames(FC.tot[[i]]))
            FC.tot[[i]] <- FC.tot[[i]][ind,]
        }
        
        out <- FC.tot
        
        
        return(out)
    }
}

### fcros calculation based on the first option ###

diffScoreMult1_fcros <- function(expr.data, gene.sets, labels, comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    FC.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        FC.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of FC-scores for original data for a particular comparison ##
        ind1 <- which(labels==CompGroups[[i]][1])
        ind2 <- which(labels==CompGroups[[i]][2])
        expdat <- expr[,c(ind1,ind2)]
        
        
        rownames(expdat) <- rownames(expr.data)
        cont <- colnames(expdat)[1:length(ind1)]
        test <- colnames(expdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        log2.opt <- 0
        trim.opt <- 0.2
        FC.tot[[i]][,1] <- fcros(expdat, cont, test, log2.opt, trim.opt)$FC2
        
        
        ## Calculation of FC-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- labels
            lb[ind] <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
            ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
            expdat <- expr[,c(ind1,ind2)]
            
            rownames(expdat) <- rownames(expr.data)
            cont <- colnames(expdat)[1:length(ind1)]
            test <- colnames(expdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            log2.opt <- 0
            trim.opt <- 0.2
            FC.tot[[i]][,k+1] <- fcros(expdat, cont, test, log2.opt, trim.opt)$FC2
        }
        
        rownames(FC.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(FC.tot[[i]])))<length(rownames(FC.tot[[i]]))){
            FC.tot[[i]] <- aggregate(FC.tot[[i]],by=list(rownames(FC.tot[[i]])),FUN=mean)
            rownames(FC.tot[[i]]) <- FC.tot[[i]][,1]
            FC.tot[[i]] <- FC.tot[[i]][,2:dim(FC.tot[[i]])[2]]
            ind <- match(rownames(gene.sets),rownames(FC.tot[[i]]))
            FC.tot[[i]] <- FC.tot[[i]][ind,]
        }
        
        out <- FC.tot
        
        
        return(out)
    }
}





######################

### t-score calculation based on the second option ###
diffScoreMult2_limma <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
  require(limma)
  require(Biobase)
  expr <- expr.data
  rownames(expr) <- NULL
  ##For example, CompGroups <- c(1,3) for groups one and third ##
  m <- gregexpr("[0-9]+",comparisons)
  CompGroups <- regmatches(comparisons,m)
  dime2 <- dim(expr)
  tscores.tot <- list()
  #dime <- list()

  pit <- length(labels)
  perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}

  dime <- dim(perms)
  
  for(i in 1:length(CompGroups)){
    tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))


    ## Calculation of t-scores for original data for a particular comparison ##

    design <- model.matrix(~0 + as.factor(labels))
    colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
    mySet <- new("ExpressionSet",expr=as.matrix(expr))
    fit1 <- lmFit(mySet, design)
    cont.matrix <- makeContrasts(contrasts=comparisons[i],levels=design)
    fit2 <- contrasts.fit(fit1, cont.matrix)
    fit2 <- eBayes(fit2)
    tscores.tot[[i]][,1] <- fit2$t

    ## Calculation of t-scores for permuted data for a particular comparison ##

    for(k in 1:dime[2]){
      ind <- which(labels %in% CompGroups[[i]])
      lb <- perms[,k]
      design <- model.matrix(~0+as.factor(lb))
      colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
      fit1 <- lmFit(mySet, design)
      cont.matrix <- makeContrasts(contrasts=comparisons[i],levels=design)
      fit2 <- contrasts.fit(fit1, cont.matrix)
      fit2 <- eBayes(fit2)
      tscores.tot[[i]][,k+1] <- fit2$t
    }
    
    rownames(tscores.tot[[i]]) <- rownames(expr.data)
    if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
        tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
        rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
        tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
        tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko 
        
    }
  }
#p <- list()
#for(m in 1:length(dime)){
#    p[[m]] <- dime[[m]][2]
#}
return(tscores.tot)
}


### FC calculation based on the second option ###
diffScoreMult2_fc <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    ##For example, CompGroups <- c(1,3) for groups one and third ##
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    #dime <- list()
    
    pit <- length(labels)
    perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}
    
    dime <- dim(perms)
    
    for(i in 1:length(CompGroups)){
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of fc-scores for original data for a particular comparison ##
        
        design <- model.matrix(~0 + as.factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
        
        ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
        ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        tscores.tot[[i]][,1] <- FC(exprdat,data.cl)
        
        ## Calculation of fc-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
            
            ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
            ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            tscores.tot[[i]][,k+1] <- FC(exprdat,data.cl)
        }
        
        rownames(tscores.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
            tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
            rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
            tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
            tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko
            
        }
    }
    #p <- list()
    #for(m in 1:length(dime)){
    #    p[[m]] <- dime[[m]][2]
    #}
    return(tscores.tot)
}


######################


### AD calculation based on the second option ###
diffScoreMult2_ad <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    ##For example, CompGroups <- c(1,3) for groups one and third ##
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    #dime <- list()
    
    pit <- length(labels)
    perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}
    
    dime <- dim(perms)
    
    for(i in 1:length(CompGroups)){
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of fc-scores for original data for a particular comparison ##
        
        design <- model.matrix(~0 + as.factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
        
        ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
        ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        tscores.tot[[i]][,1] <- AD(exprdat,data.cl)
        
        ## Calculation of fc-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
            
            ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
            ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            tscores.tot[[i]][,k+1] <- AD(exprdat,data.cl)
        }
        
        rownames(tscores.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
            tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
            rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
            tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
            tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko
            
        }
    }
    #p <- list()
    #for(m in 1:length(dime)){
    #    p[[m]] <- dime[[m]][2]
    #}
    return(tscores.tot)
}


######################


### WAD calculation based on the second option ###

diffScoreMult2_wad <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    ##For example, CompGroups <- c(1,3) for groups one and third ##
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    #dime <- list()
    
    pit <- length(labels)
    perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}
    
    dime <- dim(perms)
    
    for(i in 1:length(CompGroups)){
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of fc-scores for original data for a particular comparison ##
        
        design <- model.matrix(~0 + as.factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
        
        ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
        ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        tscores.tot[[i]][,1] <- WAD(exprdat,data.cl)
        
        ## Calculation of fc-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
            
            ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
            ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            tscores.tot[[i]][,k+1] <- WAD(exprdat,data.cl)
        }
        
        rownames(tscores.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
            tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
            rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
            tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
            tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko
            
        }
    }
    #p <- list()
    #for(m in 1:length(dime)){
    #    p[[m]] <- dime[[m]][2]
    #}
    return(tscores.tot)
}


######################
### fcros calculation based on the second option ###

diffScoreMult2_fcros <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    ##For example, CompGroups <- c(1,3) for groups one and third ##
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    #dime <- list()
    
    pit <- length(labels)
    perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}
    
    dime <- dim(perms)
    
    for(i in 1:length(CompGroups)){
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of fc-scores for original data for a particular comparison ##
        
        design <- model.matrix(~0 + as.factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
        
        ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
        ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        cont <- colnames(exprdat)[1:length(ind1)]
        test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        log2.opt <- 0
        trim.opt <- 0.2
        tscores.tot[[i]][,1] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        
        ## Calculation of fc-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
            
            ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
            ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            
            cont <- colnames(exprdat)[1:length(ind1)]
            test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            log2.opt <- 0
            trim.opt <- 0.2
        
            tscores.tot[[i]][,k+1] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        }
        
        rownames(tscores.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
            tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
            rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
            tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
            tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko
            
        }
    }
    #p <- list()
    #for(m in 1:length(dime)){
    #    p[[m]] <- dime[[m]][2]
    #}
    return(tscores.tot)
}


######################

### cyberT calculation based on the second option ###

diffScoreMult2_cyberT <- function(expr.data, gene.sets, labels, comparisons, perm.number,...){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    ##For example, CompGroups <- c(1,3) for groups one and third ##
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    #dime <- list()
    
    pit <- length(labels)
    perms <- replicate(perm.number,sample(labels,pit,replace=FALSE))
    #unique.perm <- unique(t(perms))
    #if(dim(unique.perm)[1]<perm.number){
    #  cat("Number of unique permutations:", dim(unique.perm)[1],sep="\n")
    #  perms <- t(unique.perm)
    #}
    
    dime <- dim(perms)
    
    for(i in 1:length(CompGroups)){
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        
        
        ## Calculation of fc-scores for original data for a particular comparison ##
        
        design <- model.matrix(~0 + as.factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(as.factor(labels)))),sep="")
        
        ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
        ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
        exprdat <- expr.data[,c(ind1,ind2)]
        
        res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        tscores.tot[[i]][,1] <-as.numeric(res[,ind])
        
        ## Calculation of fc-scores for permuted data for a particular comparison ##
        
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            colnames(design) <- paste("group",c(1:length(levels(as.factor(lb)))),sep="")
            
            ind1 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][1])]==1))
            ind2 <- as.numeric(which(design[,as.numeric(CompGroups[[i]][2])]==1))
            exprdat <- expr.data[,c(ind1,ind2)]
            
            
            res <- bayesT(exprdat,length(ind1),length(ind2), ppde=FALSE)
            ind <- grep("bayesT",colnames(res))

            tscores.tot[[i]][,k+1] <- as.numeric(res[,ind])
        }
        
        rownames(tscores.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[i]])))<length(rownames(tscores.tot[[i]]))){
            tscores.tot[[i]] <- aggregate(tscores.tot[[i]],by=list(rownames(tscores.tot[[i]])),FUN=mean)
            rownames(tscores.tot[[i]]) <- tscores.tot[[i]][,1]
            tscores.tot[[i]] <- tscores.tot[[i]][,2:dim(tscores.tot[[i]])[2]]
            tscores.tot[[i]][order(match(rownames(tscores.tot[[i]]),rownames(gene.sets))),] ##thapeko
            
        }
    }
    #p <- list()
    #for(m in 1:length(dime)){
    #    p[[m]] <- dime[[m]][2]
    #}
    return(tscores.tot)
}

###################################





toMatrix <-
function(expr.data, gene.sets){
  if(is.matrix(gene.sets) | is.array(gene.sets) | is.data.frame(gene.sets) | is.table(gene.sets) ){
    gene.sets <- as.matrix(gene.sets)
    }

  if(is.list(gene.sets)){
    
      gene.set.matrix <- listTOclMatrix(rownames(expr.data),gene.sets)
      gene.set.size <- dim(gene.set.matrix)
      colnames(gene.set.matrix) <- names(gene.sets)
      rownames(gene.set.matrix) <- rownames(expr.data)
      gene.sets <- gene.set.matrix
    
    
  }
  return(gene.sets)
}

#############

listTOclMatrix <-
function(gene.vector, GO.list){
	num.classes <- length(GO.list)
	result <- list()
	for(i in 1:num.classes){
		result[[i]] <- gene.vector%in%GO.list[[i]]
	}
	out <- 1*(matrix(unlist(result),ncol=num.classes))
	return(out)
}

#############

flipListStruct <- function(data){
    list_len <- length(data)
    max_val = 0
    ind_vals <- rep(0,list_len)
    loop_val <- 1
    for(k in 1:list_len){
        if(length(data[[k]])> 0){
            if(length(data[[k]])> 1 || data[[k]] > 0) {
                ind_vals[loop_val] <- k
                loop_val <- loop_val + 1
                max_val <- max(max_val, max(data[[k]]) )
            }
        }
        
    }
    ind_vals <- ind_vals[ind_vals > 0]
    out <- list(NULL)
    out[[max_val+1]] = 1
    out[[max_val+1]] = NULL 
    for(k in ind_vals){
        for(l in data[[k]] ){  
            out[[l]] <- c(out[[l]], k)
        }
    }
    out 
}

#############
mGSZ.test.score <-
function(expr.data, gene.sets, wgt1 = 0.2, wgt2 = 0.5, pre.var = 0, var.constant = 10, start.val = 5, flip.gene.sets = FALSE, table = FALSE,...){

    num.genes <- length(expr.data)

  # Ordering of gene expression data and gene sets data

  gene.sets <- toMatrix(expr.data,gene.sets)
  ord_out <- order(expr.data, decreasing= TRUE)
  expr.data <- expr.data[ord_out]
  set.dim <- dim(gene.sets)
  cols <- set.dim[2]
  gene.sets <- gene.sets[ord_out,]
 
    
  expr.data.ud <- expr.data[num.genes:1] # expression values turned up-side down
                                         # This does the analysis of the lower end


	num.genes=length(expr.data)
	num.classes=dim(gene.sets)[2]
	set_sz <- apply(gene.sets,2,sum)
	unique_class_sz_ln <- length(unique(set_sz))
	
	
	### Defining variables for different output

	mAllez <- rep(0,num.classes)
	mgsa <- matrix(0,2,num.classes)

	pre_z_var.1 <- sumVarMean_calc(expr.data, gene.sets, pre.var)
	pre_z_var.2 <- sumVarMean_calc(expr.data.ud, gene.sets, pre.var)
	
	Z_var1 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.1$Z_var,wgt2,var.constant)
	Z_var2 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.2$Z_var,wgt2,var.constant)

	out2 = matrix(0,2,num.classes)
	mgsa1 <- numeric(num.classes)
	mgsa2 <- mgsa1
	mgsz1 <- mgsa1
	mgsz2 <- mgsa2
	for (k in 1:num.classes){
		po1 <- which(gene.sets[,k]==1)
		po0 <- which(gene.sets[,k]==0)
		if(length(po1) > 0 & length(po0) > 0){
			tmp1 = expr.data
			tmp1[po0] = 0
			tmp0 = expr.data
			tmp0[po1] = 0
			result1 = cumsum(tmp1)-cumsum(tmp0)-pre_z_var.1$Z_mean[,pre_z_var.1$class_size_index[k]]
			result2 = cumsum(tmp1[num.genes:1])-cumsum(tmp0[num.genes:1])-pre_z_var.2$Z_mean[,pre_z_var.2$class_size_index[k]]
			
			result1[1:start.val] <- 0
			result2[1:start.val] <- 0
			A = result1/Z_var1[,pre_z_var.1$class_size_index[k]]
			B = result2/Z_var2[,pre_z_var.2$class_size_index[k]]
			mAllez[k] <- abs(A[num.genes])
			mgsa1[k] <- A[round(num.genes/2)]
			mgsa2[k] <- B[round(num.genes/2)]
			mgsz1[k] <- max(abs(A))
			mgsz2[k] <- max(abs(B))
			
	    }
    }
    mgsa[1,]<-mgsa1
    mgsa[2,]<-mgsa2
    out2[1,]<-mgsz1
    out2[2,]<-mgsz2
    if(table){
        out <- cbind(Gene.sets = colnames(gene.sets), mGSZ.scores = apply(out2,2,max), mAllez.scores = mAllez, mGSA.scores = apply(abs(mgsa),2,max))
    }
    else{
    out = list(mGSZ.scores = apply(out2,2,max), mAllez.scores = mAllez, mGSA.scores= apply(abs(mgsa),2,max))
    return(out)}
    
 }
#########

emp <-
function(pos.data, neg.data){
    
    neg.dat.sz <- dim(neg.data)
    test_data <- rep(0, neg.dat.sz[2])
    for (k in 1:neg.dat.sz[2]){
        test_data[k] <- length(which(neg.data[,k] >= pos.data[k]))
    }
    test_data[test_data == 0] <- 0.5
    test_data <- (test_data)/(neg.dat.sz[1])
    #test_data <- -log10(test_data)
    test_data
    
    
}

############

emp.wrs <-
function(pos.data, neg.data){
    neg.dat.sz <- dim(neg.data)
    test_data <- rep(0, neg.dat.sz[2])
    for (k in 1:neg.dat.sz[2]){
        test_data[k] <- length(which(neg.data[,k] >= abs(pos.data[k])))
    }
    test_data[test_data == 0] <- 0.5
    test_data <- (test_data)/(neg.dat.sz[1])
    #test_data <- -log10(test_data)
    test_data
}

###############

KS.p.values <-
function(pos.data, perm.data){
	#library(MASS)
	tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
	pos.data <- tmp$pos.out
	perm.data <- tmp$perm.out
	rm(tmp)
	col.ind <- pick.data.cols(perm.data)
    perm.data <- perm.data[,col.ind]
	pos.data <- pos.data[col.ind]
	emp.pval.class <- emp(pos.data, perm.data)
		
    output <- list(EMP.class=emp.pval.class,class.ind=col.ind)
    
    
    return(output)
}

###############

logEVcdf <-
function(x, mu, sigma) {
    
    x <- (mu - x)/sigma  # Note! Flip the sign here
    out <- rep(0, length(x))
    if(!(is.vector(x)) ){
        d.sz <- dim(x)
        out <- matrix(out, d.sz[1], d.sz[2])
    }
    po1 <- which(x < 5) # switch for appr. vs. norm. eq.
    out[po1] <- -log(1 - exp(-exp(x[po1])) )
    x <- x[-po1]
    out[-po1] <- -x + exp(x)/2 - exp(2*x)/24 + exp(4*x)/2880 #Polyn. Expansion
    out <- out/log(10)
    out <- 10^(-out)
    out
}

###############

logNORMcdf <-
function(x,mu,sigma){
	z <- (x-mu)/(sigma)
	
	#out <- rep(0,length(x))
	if(!(is.vector(x)) ){
        d.sz <- dim(x)
        out <- matrix(out, d.sz[1], d.sz[2])
    }
  	out <- pnorm(-z,lower.tail=T)
  	#out <- -log10(out)
    
  	out
}

###############

mAllez.p.values <-
function(pos.data, perm.data){
	#library(MASS)
	tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
	pos.data <- tmp$pos.out
	perm.data <- tmp$perm.out
	rm(tmp)
	col.ind <- pick.data.cols(perm.data)
	perm.data <- perm.data[,col.ind]
	pos.data <- pos.data[col.ind]
	norm.param.all <- fitdistr(as.numeric(perm.data),'normal')$estimate
	norm.pval.class <- rep(0,length(pos.data))
	
	for (k in 1:length(pos.data)){
        norm.param.class <- fitdistr(as.vector(perm.data[,k]),'normal')$estimate
    	norm.pval.class[k] <- logNORMcdf(pos.data[k],norm.param.class[1],norm.param.class[2])

	}
	

    output <- list(NORM.class=norm.pval.class,class.ind=col.ind)
    output
	
}

################

mGSA.p.values <-
function(pos.data, perm.data) {
    #library(ismev)
    #library(MASS)
    tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
    scaled.pos.data <- tmp$pos.out
    scaled.perm.data <- tmp$perm.out
    rm(tmp)
    get.perm.p.vals = FALSE
    perm.dat.sz <- dim(scaled.perm.data)
    col.ind <- pick.data.cols(scaled.perm.data) # discard cols with null var

    # First fit the parameters to the whole data
    scaled.perm.data <- scaled.perm.data[,col.ind]
    scaled.pos.data <- scaled.pos.data[col.ind]
    ev.p.val.class  <- rep(0, length(scaled.pos.data))
        
    for (k in 1:length(scaled.pos.data)){
        
        # Following fits parameters to perms of each class
        ev.param.class  <- gum.fit(as.vector(scaled.perm.data[,k]),show=FALSE)$mle
        ev.p.val.class[k]  <- logEVcdf(scaled.pos.data[k], ev.param.class[1], ev.param.class[2]  )
        
        }
        output <- list(EV.class = ev.p.val.class,class.ind=col.ind)
        
        output
}

###############

mGSZ.p.values <-
function(pos.data, perm.data) {
    #library(ismev)
    #library(MASS)
    tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
    pos.data <- tmp$pos.out
    perm.data <- tmp$perm.out
    rm(tmp)
    get.perm.p.vals = FALSE
    perm.dat.sz <- dim(perm.data)
    col.ind <- pick.data.cols(perm.data)
    perm.data <- perm.data[,col.ind]
    pos.data <- pos.data[col.ind]
    ev.p.val.class  <- rep(0,length(pos.data))
        
    
    for (k in 1:length(pos.data)){

        # Following fits parameters to perms of each class
        ev.param.class  <- gum.fit(as.vector(perm.data[,k]),show=FALSE)$mle
        ev.p.val.class[k]  <- logEVcdf(pos.data[k], ev.param.class[1], ev.param.class[2]  )
        }

        output <- list(EV.class = ev.p.val.class,class.ind=col.ind)
        
    
    output
}

###############

SS.p.values <-
function(pos.data, perm.data){
	#library(MASS)
    tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
    
	scaled.pos.data <- tmp$pos.out
	scaled.perm.data <- tmp$perm.out
	rm(tmp)
	col.ind <- pick.data.cols(scaled.perm.data)
	div.length <- length(scaled.perm.data)
	scaled.perm.data <- scaled.perm.data[,col.ind]
	scaled.pos.data <- scaled.pos.data[col.ind]
    emp.pval.class <- emp(scaled.pos.data, scaled.perm.data)
    output <- list(EMP.class = emp.pval.class,class.ind=col.ind )
    output
	
}

##############

WRS.p.values <-
function(pos.data, perm.data){
	#library(MASS)
	tmp <- mGSZ.adj.mean.std(pos.data, perm.data)
	pos.data <- tmp$pos.out
	perm.data <- tmp$perm.out
	rm(tmp)
	col.ind <- pick.data.cols(perm.data)
    perm.data <- perm.data[,col.ind]
	pos.data <- pos.data[col.ind]
    emp.pval.class <- emp.wrs(pos.data, perm.data)
    norm.pval.class <- rep(0,length(pos.data))

    output <- list(EMP.class=emp.pval.class,class.ind=col.ind)
    
    output
	
}

################

mGSZ.adj.mean.std <-
function(pos.data, perm.data) {
   perm.sz <- dim(perm.data)
   mean.prof <- apply(perm.data, 2, mean)
   std.prof    <- apply(perm.data, 2, sd)
   null.ind <- which(std.prof == 0)  
   std.prof[null.ind] <- 0.1
   perm.out <- matrix(0, perm.sz[1], perm.sz[2])
   pos.out <- rep(0, perm.sz[2])
   for( k in 1:perm.sz[2]){
     perm.out[,k] <- ( perm.data[,k] - mean.prof[k]) /std.prof[k]
     pos.out[k]    <- ( pos.data[k] - mean.prof[k] )/std.prof[k]   
    }
   out  <- list(pos.out = pos.out, perm.out = perm.out)
   out
}

##############

pick.data.cols <-
function(data) {

    # Discard cols where var == 0
    # These disturb distribution fitting
    
    tmp <- apply(data, 2, var)
    out <- which(tmp > 0)
    out
}

#############

StabPlotData1 <-
function(mGSZobj,rank.vector, comp.ind){

## comp.ind: index of comparisons, for example 1,2 etc.
   ########################################
   ## Testing that data sizes are correct #
   ########################################
   
   mGSZobj <- mGSZobj[[comp.ind]]
   gene.sets <- mGSZobj$gene.sets
   expr.data <- mGSZobj$expr.data
   expr.dat.sz <- dim(expr.data)
   perm.number <- mGSZobj$perm.number
   sample.labels <- mGSZobj$sample.labels
   flip.gene.sets <- mGSZobj$flip.gene.sets
   min.cl.sz <- mGSZobj$min.cl.sz
   pre.var <- mGSZobj$pre.var
   wgt1 <- mGSZobj$wgt1
   wgt2 <- mGSZobj$wgt2
   var.constant <- mGSZobj$var.constant
   start.val <- mGSZobj$start.val
   
    
   geneset.classes <- colnames(gene.sets)
   num.classes <- dim(gene.sets)[2]
   num.genes <- dim(expr.data)[1]
   geneset.class.sizes <- colSums(gene.sets)

        
   tmp.expr.data = mGSZobj$tmp.expr.data
   diff.expr.dat.sz <- dim(tmp.expr.data)
    
        
   gene.sets.stb <- as.vector(mGSZobj$table[,1][rank.vector])


	
	## mGSZ for positive data ####
	#############################
	pos.scores <- mGSZ.test.score.stb2(gene.sets.stb=gene.sets.stb,expr.data=tmp.expr.data[,1], gene.sets,wgt1=wgt1,wgt2=wgt2,pre.var=pre.var,var.constant=var.constant,start.val=start.val)
    mGSZ.up <- pos.scores$mGSZ.up

    ## mGSZ for col randomized data ###
	##################################
	
	col.perm.mGSZ <- matrix(0, diff.expr.dat.sz[2]-1, num.classes)
    perm.number <- diff.expr.dat.sz[2]-1
    mGSZ.cperm.up <- vector("list",length(rank.vector))

	
    for( k in 1:(diff.expr.dat.sz[2]-1)){
    	tmp <- mGSZ.test.score.stb3(gene.sets.stb=gene.sets.stb,expr.data=tmp.expr.data[,k+1], gene.sets=gene.sets,wgt1=wgt1,wgt2=wgt2,pre.var=pre.var,var.constant=var.constant,start.val=start.val)
        mGSZ.cperm.up[[k]] <- tmp$mGSZ.up

     }
     
     out <- list(positive.prof.up = mGSZ.up, perm.data = mGSZ.cperm.up, expr.data = expr.data, gene.sets = gene.sets, perm.number = perm.number,rank.vector=rank.vector,gene.sets.stb=gene.sets.stb)
     
     return(out)
}

 ####################
 ####################
 
 
 
 
 mGSZ.test.score.stb2 <-
function(gene.sets.stb, expr.data, gene.sets, wgt1, wgt2, pre.var, var.constant,start.val){
	

  num.genes <- length(expr.data)

  # Ordering of gene expression data and gene sets

  ord_out <- order(expr.data, decreasing= TRUE)
  expr.data <- expr.data[ord_out]
  set.dim <- dim(gene.sets)
  cols <- set.dim[2]
  gene.sets <- gene.sets[ord_out,] 
                           
 
  expr.data.ud <- expr.data[num.genes:1] 
                                         


	num.genes=length(expr.data)
	num.classes=dim(gene.sets)[2]
	set_sz <- apply(gene.sets,2,sum)
	unique_class_sz_ln <- length(unique(set_sz))
	
	
	### Defining variables for different output
	
    mGSZ.up <- list()
    #GSZ.down <- list()

    pre_z_var.1 <- sumVarMean_calc(expr.data, gene.sets, pre.var)
	pre_z_var.2 <- sumVarMean_calc(expr.data.ud, gene.sets, pre.var)
	
	Z_var1 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.1$Z_var,wgt2,var.constant)
	Z_var2 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.2$Z_var,wgt2,var.constant)

	out2 = matrix(0,2,num.classes)
	mgsz1 <- numeric(num.classes)
	mgsz2 <- mgsz1
    
	
	for (k in 1:num.classes){
		po1 <- which(gene.sets[,k]==1)
		po0 <- which(gene.sets[,k]==0)
		if(length(po1) > 0 & length(po0) > 0){
			tmp1 = expr.data
			tmp1[po0] = 0
			tmp0 = expr.data
			tmp0[po1] = 0
			result1 = cumsum(tmp1)-cumsum(tmp0)-pre_z_var.1$Z_mean[,pre_z_var.1$class_size_index[k]]
			result2 = cumsum(tmp1[num.genes:1])-cumsum(tmp0[num.genes:1])-pre_z_var.2$Z_mean[,pre_z_var.2$class_size_index[k]]
			
			result1[1:start.val] <- 0
			result2[1:start.val] <- 0
			A = result1/Z_var1[,pre_z_var.1$class_size_index[k]]
			B = result2/Z_var2[,pre_z_var.2$class_size_index[k]]

            if(colnames(gene.sets)[k] %in% gene.sets.stb){
            
            mGSZ.up[[length(mGSZ.up)+1]] <- (A)
            #GSZ.down[[length(mGSZ.down)+1]] <- (B)
            }
    
			mgsz1[k] <- max(abs(A))
			mgsz2[k] <- max(abs(B))
			
	    }
    }
    
    out2[1,]<-mgsz1
    out2[2,]<-mgsz2
    result1 = list(GSZ.result = apply(out2,2,max))
    result2 = list(Z_var1=Z_var1,Z_var2=Z_var2,Z_mean1=pre_z_var.1$Z_mean,Z_mean2=pre_z_var.2$Z_mean,class_size_index1=pre_z_var.1$class_size_index,class_size_index2=pre_z_var.2$class_size_index)
    
    out = list(gene.set.scores=result1, var.attributes=result2,mGSZ.up=mGSZ.up)

    return(out)
 }

################

mGSZ.test.score.stb3 <-
function(gene.sets.stb, expr.data, gene.sets, wgt1, wgt2, pre.var, var.constant,start.val,...){
	

  num.genes <- length(expr.data)

  # Ordering of gene expression data and gene set data

 
    
      ord_out <- order(expr.data, decreasing= TRUE)
      expr.data <- expr.data[ord_out]
      set.dim <- dim(gene.sets)
      cols <- set.dim[2]
      gene.sets <- gene.sets[ord_out,]
                                          
  

  expr.data.ud <- expr.data[num.genes:1] 
                                         


	num.genes=length(expr.data)
	num.classes=dim(gene.sets)[2]
	set_sz <- apply(gene.sets,2,sum)
	unique_class_sz_ln <- length(unique(set_sz))
	
	
	### Defining variables for different output

    mGSZ.up <- list()
    #GSZ.down <- list()
	
	pre_z_var.1 <- sumVarMean_calc(expr.data, gene.sets, pre.var)
	pre_z_var.2 <- sumVarMean_calc(expr.data.ud, gene.sets, pre.var)
	
	Z_var1 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.1$Z_var,wgt2,var.constant)
	Z_var2 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.2$Z_var,wgt2,var.constant)

	out2 = matrix(0,2,num.classes)
	mgsz1 <- numeric(num.classes)
	mgsz2 <- mgsz1
   

	for (k in 1:num.classes){
		po1 <- which(gene.sets[,k]==1)
		po0 <- which(gene.sets[,k]==0)
		if(length(po1) > 0 & length(po0) > 0){
			tmp1 = expr.data
			tmp1[po0] = 0
			tmp0 = expr.data
			tmp0[po1] = 0
			result1 = cumsum(tmp1)-cumsum(tmp0)-pre_z_var.1$Z_mean[,pre_z_var.1$class_size_index[k]]
			result2 = cumsum(tmp1[num.genes:1])-cumsum(tmp0[num.genes:1])-pre_z_var.2$Z_mean[,pre_z_var.2$class_size_index[k]]
			
			result1[1:start.val] <- 0
			result2[1:start.val] <- 0
			A = result1/Z_var1[,pre_z_var.1$class_size_index[k]]
			B = result2/Z_var2[,pre_z_var.2$class_size_index[k]]
            
            if(colnames(gene.sets)[k] %in% gene.sets.stb){
                
                mGSZ.up[[length(mGSZ.up)+1]] <- (A)
                #mGSZ.down[[length(mGSZ.down)+1]] <- (B)
                }
			mgsz1[k] <- max(abs(A))
            mgsz2[k] <- max(abs(B))
			
	    }
    }
    out2[1,]<-mgsz1
    out2[2,]<-mgsz2
    out = list(mGSZ.result = apply(out2,2,max),mGSZ.up=mGSZ.up)

    return(out)
    
 }

#################

plotProfile <-
function(data,rank){

# data: dataForStabPlot object
# rank: rank of the gene set
# gene.perm: TRUE for plotting gene perm data


    rv <- data$rank.vector
    rnk <- match(rank,rv)
    geneset <- data$gene.sets.stb[rnk]
    cat(geneset)
    ind <- match(data$gene.sets.stb,colnames(data$gene.sets))
    ord <- order(ind)
    rank.vector <- data$rank.vector[ord]
    rank <- match(rank, rank.vector)
    pos.data <- (data$positive.prof.up)[[rank]]
    perm.data <- matrix(0,data$perm.number,length(pos.data))
    for(i in 1:data$perm.number){
           perm.data[i,]= data$perm.data[[i]][[rank]]}
    
    
    quantiles <-  apply(perm.data,2,quantile,probs=c(0,0.10,0.25,0.50,0.75,0.90,1))
    total.data <- rbind(pos.data,quantiles)
    df <- data.frame(Real.data= total.data[1,],Q1 = total.data[2,],Q2=total.data[3,], Q3 = total.data[4,], Q4=total.data[5,],Q5=total.data[6,],Q6=total.data[7,],Q7=total.data[8,])
    plot(df$Real.data,lwd=3,type="l",xlab="Ordered gene list",ylab="Running scores",font=2,font.lab=2,family="sans",ylim=c(min(as.numeric(perm.data),as.numeric(pos.data)),max(as.numeric(perm.data),as.numeric(pos.data))),xlim=c(1,length(pos.data)+ (length(pos.data))/5))
    lines(df$Q1,col="red",lty=2,lwd=3)
    lines(df$Q2,col="blue",lty=2,lwd=3)
    lines(df$Q3,col="green",lty=2,lwd=3)
    lines(df$Q4,col="purple",lty=2,lwd=3)
    lines(df$Q5,col="magenta",lty=2,lwd=3)
    lines(df$Q6,col="pink",lty=2,lwd=3)
    lines(df$Q7,col="grey",lty=2,lwd=3)
    legend("topright",c("True data","0.00","0.10","0.25","0.50","0.75","0.90","1.00"),lty=c(1,2,2,2,2,2,2,2),col=c("black","red","blue","green","purple","magenta","pink","grey"),bty="n",lwd=3,cex=.70)}



################


## Sub-functions #
## FC is computed with non-log signals ##

FC <- function(x, cl){
    x <- 2^x                    
    x.class1 <- x[(cl == 1)]    
    x.class2 <- x[(cl == 2)]    
    hoge <- log2(mean(x.class2)/mean(x.class1))
    return(hoge)
}


########

###############

mGSZ.test.score22 <-
function(expr.data, gene.sets, wgt1, wgt2, pre.var, var.constant,start.val, flip.gene.sets = FALSE,...){
	
  num.genes <- length(expr.data)

  # Ordering of gene expression data and gene sets data

  gene.sets <- toMatrix(expr.data,gene.sets)
  ord_out <- order(expr.data, decreasing= TRUE)
  expr.data <- expr.data[ord_out]
  set.dim <- dim(gene.sets)
  cols <- set.dim[2]
  gene.sets <- gene.sets[ord_out,] 
                           

 
  expr.data.ud <- expr.data[num.genes:1] # expression values turned up-side down
                                         # This does the analysis of the lower end


	num.genes=length(expr.data)
	num.classes=dim(gene.sets)[2]
	set_sz <- apply(gene.sets,2,sum)
	unique_class_sz_ln <- length(unique(set_sz))
	
	mAllez <- rep(0,num.classes)
    
	mgsa <- matrix(0,2,num.classes)

	pre_z_var.1 <- sumVarMean_calc(expr.data, gene.sets, pre.var)
	pre_z_var.2 <- sumVarMean_calc(expr.data.ud, gene.sets, pre.var)
	
	Z_var1 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.1$Z_var,wgt2,var.constant)
	Z_var2 = calc_z_var(num.genes,unique_class_sz_ln, pre_z_var.2$Z_var,wgt2,var.constant)

	out2 = matrix(0,2,num.classes)
	mgsa1 <- numeric(num.classes)
	mgsa2 <- mgsa1
	mgsz1 <- mgsa1
	mgsz2 <- mgsa2
	for (k in 1:num.classes){
		po1 <- which(gene.sets[,k]==1)
		po0 <- which(gene.sets[,k]==0)
		if(length(po1) > 0 & length(po0) > 0){
			tmp1 = expr.data
			tmp1[po0] = 0
			tmp0 = expr.data
			tmp0[po1] = 0
			result1 = cumsum(tmp1)-cumsum(tmp0)-pre_z_var.1$Z_mean[,pre_z_var.1$class_size_index[k]]
			result2 = cumsum(tmp1[num.genes:1])-cumsum(tmp0[num.genes:1])-pre_z_var.2$Z_mean[,pre_z_var.2$class_size_index[k]]
			
			result1[1:start.val] <- 0
			result2[1:start.val] <- 0
			A = result1/Z_var1[,pre_z_var.1$class_size_index[k]]
			B = result2/Z_var2[,pre_z_var.2$class_size_index[k]]
           
            mAllez[k] <- abs(A[num.genes])
			mgsa1[k] <- A[round(num.genes/2)]
			mgsa2[k] <- B[round(num.genes/2)]
			mgsz1[k] <- max(abs(A))
			mgsz2[k] <- max(abs(B))
			
	    }
    }
    mgsa[1,]<-mgsa1
    mgsa[2,]<-mgsa2
    out2[1,]<-mgsz1
    out2[2,]<-mgsz2
    result1 = list(mGSZ.scores = apply(out2,2,max), mAllez.scores = mAllez, mGSA.scores= apply(abs(mgsa),2,max))
    result2 = list(Z_var1=Z_var1,Z_var2=Z_var2,Z_mean1=pre_z_var.1$Z_mean,Z_mean2=pre_z_var.2$Z_mean,class_size_index1=pre_z_var.1$class_size_index,class_size_index2=pre_z_var.2$class_size_index)
    
    out = list(gene.set.scores=result1, var.attributes=result2)
    return(out)
 }

############

################################################################################
# This function performs a similar operation to the Unix command 'ls -l'
# It works like ls() in R except that it will also display object class,
# dimension/length, and object size.
# It can also take a class filter to view only objects of a certain type.
#
# Usage:
# lls() # list all objects
# lls(environmentName) # list all the objects in the specified environment
# lls(pattern="foo") # list all objects whose name matches pattern specified
# lls(classFilter="data.frame") # find all data frame objects
#
# BAsed on  code of  Scillieri, John
# http://tolstoy.newcastle.edu.au/R/e6/help/09/03/7493.html
#
# Modified by Petri Tˆrˆnen (Toronen), Helsinki University
# petri_dot_toronen_at_helsinki_dot_fi
# I tried to please my Matlab-adjusted eyes, while generating the nice output screen ;-)
# email improvements/corrections. Thanks.
#######################################################################################


lls <- function(name, pos=-1, envir=as.environment(pos), all.names=FALSE,   pattern, classFilter)
{
    
    if( !missing(name) )
    {
        envir = name
    } else
    {
        envir = parent.frame()
    }
    
    lsList = ls(name, pos, envir, all.names, pattern)
    
    tmpLength <- 0  # PT added code here
    for(item in lsList) {
        tmp <- nchar(item)
        if(tmp > tmpLength){
            tmpLength <- tmp
        }
    } # PT addition ended
    
    
    
    cat("\nName: Class, Length, Size\n")
    cat("-------------------------\n")
    for( item in lsList )
    
    
    {
        itemLength <- nchar(item)  # PT added code
        add_empty <- "  "
        for(i in 1:(tmpLength-itemLength)) {
            add_empty <- paste(add_empty, " ", sep = "");
        }
        item_out <- paste(item, add_empty, sep= "")
        realItem = eval(parse(text = item), envir)
        itemClass = class(realItem)
        itemSize = object.size(realItem)
        itemDimension = paste(dim(realItem), collapse="x" )
        if( itemDimension == "" )
        {
            itemDimension = length(realItem)
        }
        
        classFilterMatches = !missing(classFilter) && itemClass == classFilter
        if( classFilterMatches || missing(classFilter) )     {
            
            format(cat(item_out, ": ", itemClass, ",\t", itemDimension, ",\t", itemSize, "\n",
            sep=""), justify="centre")
            
            
        }
    }
    cat("\n")
    
    invisible(lsList)
}

################################################################################
# Overload the internal object.size function to return the size in B/KB/MB
#

object.size <-function(x){

    
    size = .Internal(object.size(x))
    
    if (size<1024)
    {
        
        size=paste(size, "B")
    }
    else if (size>=1024 & size < 1024*1024)     {
        
        size=paste( round(size/1024, 1), "KB")     }
    else
    {
        
        size=paste( round( size/1024/1024, 1 ),"MB")     }     
    
    return(size)
}
#############

diffScoreMult3_mlimma <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
        
        org.tscores <- list()
        designnn <- model.matrix(~0 + factor(labels))
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            design <- model.matrix(~lbs)
            mySet <- new("ExpressionSet",expr=as.matrix(exprdat))
            fit1 <- lmFit(mySet, design)
            fit2 <- eBayes(fit1)
            org.tscores[[i]] <- fit2$t[,2]
        }
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.tscores <- vector("list",perm.number)
        for(k in 1:perm.number){
            perm.t <- list()
            designnn <- perm.designs[[k]]
            colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            for(i in 1:length(comparisons)){
                grp.ind <- getNumeric(comparisons[i])
                ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
                ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
                exprdat <- expr[,c(ind1,ind2)]
                lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
                design <- model.matrix(~lbs)
                mySet <- new("ExpressionSet",expr=as.matrix(exprdat))
                fit1 <- lmFit(mySet, design)
                fit2 <- eBayes(fit1)
                perm.t[[i]] <- fit2$t[,2]
            }
            perm.tscores[[k]] <- perm.t
        }
        
        tscores.tot <- list()
        for(i in 1:length(comparisons)){
            tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
        }
        
        for(j in 1:length(comparisons)){
            for(k in 1:perm.number){
                tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
            }
        }
        
        for(i in 1:length(comparisons)){
            tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
        }
        
        for(z in 1:length(comparisons)){
            rownames(tscores.tot[[z]]) <- rownames(expr.data)
            if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
                tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
                rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
                tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
                tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
            }
            
            ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
            tscores.tot[[z]] <- tscores.tot[[z]][ind,]
            
        }
        
        
        
        out <- tscores.tot
        
    }


#############

diffScoreMult3_cyberT <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        org.tscores[[i]] <- as.numeric(res[,ind])
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            res <- bayesT(exprdat,length(ind1),length(ind2), ppde=FALSE)
            ind <- grep("bayesT",colnames(res))
            perm.t[[i]] <- as.numeric(res[,ind])
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}

#############################


#   Copyright (C) 2004-2005 Suman Sundaresh, Computer Science Department
#   University of California, Irvine (suman@uci.edu)
#   Institute for Genomics and Bioinformatics
#   Parts of this code obtained or adapted from "hdarray" (Tony D. Long)

#   This code is free for academic, non-commercial, research use only. If you use this library, please
#   cite the reference (Baldi and Long, 2001) - details are on the Cyber-T
#   Help webpage. Also, please keep all headers in this code as is.
#   For commercial licenses, please contact Pierre Baldi (pfbaldi@uci.edu).


#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

#   bayesreg: v2.0beta

ALMOST_ZERO = 10E-14;
################################################################################
##   bayesT
##
##       Adata - Actual data frame (ncol = numC + numE) contiguous controls then experimentals
##       ppde = FDR test.., fits a beta and uniform mixture dist to the resulting p-values.
##           BETAFIT - param for ppde
##       bayes = do bayesian est of variance
##       winSize = how big around sorted dpoints for prior calc, has to be odd.
##       conf = degrees of freedom for each population prior calculation.
##              (how many dpoints do we believe make up the prior?)
##       doMulttest - allow BH and Bonferroni adjusted p-vals to be
##                   calculated right here.
##       bayesIntC - use similar means (instead of similar variances) to calculate bayesian variance
##                   for the Controls
##       bayesIntE - use similar means (instead of similar variances) to calculate bayesian variance
##                   for the Experimentals
################################################################################
bayesT <- function (aData, numC, numE, ppde=TRUE, betaFit=1, bayes=TRUE, winSize=101, conf=10,
doMulttest=FALSE, bayesIntC=FALSE, bayesIntE=FALSE){
    if ((ceiling((winSize-1)/2))!=((winSize-1)/2))
    stop("ERROR: winSize must be an odd number.")
    
    numGene<- nrow(aData)
    
    ## compute number of valid entries for each gene
    nC <- apply(as.matrix(aData[, 1:numC]), 1, function(x) sum(!is.na(x)))
    nE<- apply(as.matrix(aData[, (numC+1):(numC+numE)]), 1, function(x) sum(!is.na(x)))
    
    ## compute means for valid entries
    meanC<- apply(as.matrix(aData[, 1:numC]), 1, function(x)
    if (sum(!is.na(x)))
    mean(x[!is.na(x)])
    else NA)
    meanE<- apply(as.matrix(aData[, (numC+1):(numC+numE)]), 1, function(x)
    if (sum(!is.na(x)))
    mean(x[!is.na(x)])
    else NA)
    stdC<- apply(as.matrix(aData[, 1:numC]), 1, function(x)
    if (sum(!is.na(x)) > 1)
    sqrt(var(x[!is.na(x)]))
    else NA)
    stdE<- apply(as.matrix(aData[, (numC+1):(numC+numE)]), 1, function(x)
    if (sum(!is.na(x)) > 1)
    sqrt(var(x[!is.na(x)]))
    else NA)
    
    ## Calc the statistics in a Bayesian or Classical way
    if (bayes){
        ## Do something a little different if we only have a single replicate
        if (numC == 1) {bayesIntC <- TRUE};
        if (numE == 1) {bayesIntE <- TRUE};
        
        ## Here we calculate the average sds over windows of probes.
        rasdC <- rep(NA, numGene)
        if (!bayesIntC){
            ## basic case, order by means, averge the sds in a windowq.
            temp <- runavg(stdC[!is.na(stdC)][order(meanC[!is.na(stdC)])],((winSize-1)/2))
            temp <- temp[rank(meanC[!is.na(stdC)])]
            rasdC[!is.na(stdC)]<- temp
        } else {
            ## use the actual intensities ranked by the means
            cat('About to calc the bayes Variance for control using intensities.\n')
            intMat <- as.matrix(aData[!is.na(meanC), 1:numC]);
            intMat <- intMat[order(meanC[!is.na(meanC)]), ];
            temp <- runavgPool(intMat, winSize)
            temp <- temp[rank(meanC[!is.na(meanC)])]
            rasdC[!is.na(meanC)]<- temp
        }
        
        ## Same here, check for a single replicate in the experiment.
        rasdE <- rep(NA, numGene)
        if (!bayesIntE){
            temp <- runavg(stdE[!is.na(stdE)][order(meanE[!is.na(stdE)])],((winSize-1)/2))
            temp <- temp[rank(meanE[!is.na(stdE)])]
            rasdE[!is.na(stdE)]<- temp
        } else {
            cat('About to calc the bayes Variance for experimental using intensities\n')
            intMat<- as.matrix(aData[!is.na(meanE), (numC+1):(numC+numE)]);
            intMat <- intMat[order(meanE[!is.na(meanE)]), ];
            temp <- runavgPool(intMat, winSize)
            temp <- temp[rank(meanE[!is.na(meanE)])]
            rasdE[!is.na(meanE)]<- temp
        }
        
        ## Before computing the Bayes SD, go through and set StdC to almost (zero)  whereever is.na and rasdC is not NA
        ##   Vice versa for the expt data
        forBayesStdC <- stdC
        forBayesStdE <- stdE
        
        forBayesStdC[is.na(stdC) & !is.na(rasdC)] <- ALMOST_ZERO;
        forBayesStdE[is.na(stdE) & !is.na(rasdE)] <- ALMOST_ZERO;
        
        ## Set the ALMOST_ZERO for all rasdC and rasdE at zero as well.
        rasdC[rasdC == 0] <- ALMOST_ZERO;
        rasdE[rasdE == 0] <- ALMOST_ZERO;
        
        ## compute bayes sd
        if (conf + nC == 2 || conf + nE == 2){
            stop('ERROR: Zero degrees of freedom, increase the confidence parameter.');
        }
        bayesSDC<- sqrt((conf * rasdC^2 + (nC - 1) * forBayesStdC^2)/(conf + nC - 2))
        bayesSDE<- sqrt((conf * rasdE^2 + (nE - 1) * forBayesStdE^2)/(conf + nE - 2))
        
        ##For here, they were using the regular Dfs to calculate the original T value,
        ##   But if we have only a single replicate, then we need to tweak this..,
        ##   Note with a single rep, we are in effect increasing conf by 1.
        newNumC <- nC
        if (numC < 2){
            newNumC <- 2;
        }
        newNumE <- nE;
        if (numE < 2){
            newNumE <- 2;
        }
        
        sumStats <- cbind(newNumC,newNumE,meanC,meanE,bayesSDC,bayesSDE)
        ttest <- t(apply(sumStats, 1, function(x) tstat(x)))
        colnames(ttest)=c("bayesT","bayesDF","varRatio")
        ##change Bayes degree of freedom to reflect pseudo-counts
        ttest[,2] <- ttest[,2] + 2 * conf - 2
        
        ##Subtract out the fake df for each single rep case:
        toSub <- sum(c(numC ==1, numE == 1 ));
        ttest[, 2] <- ttest[, 2] - toSub;
    } else {
        ## A regular t-test
        sumStats <- cbind(nC, nE, meanC, meanE, stdC, stdE)
        ttest <- t(apply(sumStats, 1, function(x) tstat(x)))
        colnames(ttest) = c("T", "DF", "varRatio")
    }
    
    ## Pvals amd fold changes
    pVal <- 1 - pf(ttest[,1]^2, 1, ttest[,2])
    fold <- - (meanC/meanE) * ((meanE/meanC) < 1) + (meanE/meanC) * ((meanC/meanE) < 1)
    
    ## Then the final data.frame
    if (bayes){
        objBayes<- cbind(aData, nC, nE, meanC, meanE, stdC, stdE, fold, rasdC, rasdE, bayesSDC, bayesSDE,ttest,
        pVal)
    }
    else{
        objBayes<- cbind(aData, nC, nE, meanC, meanE, stdC, stdE, fold, ttest, pVal)
    }
    
    ##posterior probability of differential expression (ppde) test if wanted
    if (ppde){
        ppdeVal <- ppdeMix(as.matrix(pVal), betaFit)
        colnames(ppdeVal) = c("cum.ppde.p", "ppde.p", "ROC.x", "ROC.y")
        objBayes <- cbind(objBayes, ppdeVal)
    }
    
    ## Mult testing correction
    if (doMulttest){
        ##Bind them, last two cols of adjp list in original order
        objBayes <- data.frame(objBayes, runMulttest(pVal))
    }
    
    return(objBayes)
}

################################################################################
## Simple wrapper to load and then run vsn
################################################################################
runVsn <- function(data, ...){
    .libPaths("/home/baldig/shared_libraries/centos64/pkgs/R/2.15.1_fix/lib64/R/library")
    require(vsn)
    #cat('data in VSN: \n', colnames(data), '\n', as.vector(unlist(data[1,])), '\n',
    #    as.vector(unlist(data[2,])), '\n', as.vector(unlist(data[3, ])), '\n');
    tryCatch(data.frame(justvsn(as.matrix(data), verbose=TRUE, minDataPointsPerStratum=10, ...)),
    error=function(e){
        libs_a<-.libPaths()
        writeError('Error in running vsn.  Possible collinearity.  Check your data.')
        stop(e)
    }
    )
}

################################################################################
## Simple function to do Bonferroni and BH multiple testing correction.
################################################################################
runMulttest <- function(pvals){
    .libPaths("/home/baldig/shared_libraries/centos64/pkgs/R/2.15.1_fix/lib64/R/library")
    require(multtest);
    adjPObj <- mt.rawp2adjp(pvals, proc=c("Bonferroni", "BH"))
    ##Bind them, last two cols of adjp list in original order
    adjPObj$adjp[order(adjPObj$index), -1]
}

################################################################################
## bayesT.pair
##
## NOTE: aData needs to be log-transformed
## estExp is the last column of aData and it represents
## estimated expression for that gene
## A good value for 'estExp; would be the mean of the log of the
## "extimated expression level" over both treatments (i.e., control and
## experimentals) and replicates, where the estimated expression level for each
## gene/treatment/replicate is given as a fraction of total expression over
## all genes for that treatment/replicate.
##
## doMulttest - do Bonf and BH correction?
## bayesIntR - pool ratios for the variance, instead of pooling variances
##
################################################################################
bayesT.pair <-  function (aData, numR, ppde=TRUE, betaFit=1, bayes=TRUE, winSize=101, conf=10,
doMulttest=FALSE, bayesIntR=FALSE){
    if ((ceiling((winSize-1)/2))!=((winSize-1)/2))
    stop("ERROR: winSize must be an odd number.")
    
    estExp <- numR + 1
    numGene <- nrow(aData)
    
    ##compute number of valid entries for each gene
    nR <- apply(as.matrix(aData[, 1:numR]), 1, function(x) sum(!is.na(x)))
    
    ##compute means for valid entries
    meanR <- apply(as.matrix(aData[, 1:numR]),
    1, function(x) {
        if (sum(!is.na(x)))
        mean(x[!is.na(x)])
        else NA}
    )
    stdR <- apply(as.matrix(aData[, 1:numR]),
    1, function(x){
        if (sum(!is.na(x)) > 1)
        sqrt(var(x[!is.na(x)]))
        else NA}
    )
    
    ## Calc the statistic in a bayesian or classical manner
    if (bayes){
        rasdR <- rep(NA, numGene)
        index.col <- aData[,estExp]
        
        ## If we are using intensities, do things a little differently
        if (numR == 1){bayesIntR <- TRUE}
        
        if (!bayesIntR){
            ## Calculate averages over sd windows
            temp <- runavg(stdR[!is.na(stdR)][order(index.col[!is.na(stdR)])],((winSize-1)/2))
            temp <- temp[rank(index.col[!is.na(stdR)])]
            rasdR[!is.na(stdR)]<- temp
        } else {
            ## Calculate averages of sds over windows of intensities
            cat('About to calc bayes Variance for ratios using intensities.')
            intMat <- as.matrix(aData[!is.na(meanR), 1:numR])
            intMat <- intMat[order(meanR[!is.na(meanR)]), ]
            temp <- runavgPool(intMat, winSize)
            temp <- temp[rank(meanR[!is.na(meanR)])]
            rasdR[!is.na(meanR)] <- temp
        }
        
        forBayesStdR <- stdR
        forBayesStdR[is.na(stdR)] <- ALMOST_ZERO
        
        ##compute bayes sd
        bayesSD<- sqrt((conf * rasdR^2 + (nR - 1) * forBayesStdR^2)/(conf + nR - 2))
        ttest<- sqrt(nR) * (meanR/bayesSD)
        
        ##change Bayes degree of freedom to reflect pseudo-counts
        bayesDF <- nR + conf - 2
        pVal <- 1 - pf(ttest^2, 1, bayesDF)
    }
    else{
        ## Calc the basic paired tstats
        ttest <- sqrt(nR) * (meanR/stdR)
        DF <- nR - 1
        pVal <- 1 - pf(ttest^2, 1, DF)
    }
    
    ## Put together the final version of the output files
    if (bayes){
        objBayes<- data.frame(aData, nR, meanR, stdR, rasdR, bayesSD, ttest, bayesDF,pVal)
    }
    else{
        objBayes<- data.frame(aData, nR, meanR, stdR, ttest, DF, pVal)
    }
    
    ##posterior probability of differential expression (ppde) test if wanted
    if(ppde){
        ppdeVal <- ppdeMix(as.matrix(pVal),betaFit)
        colnames(ppdeVal)=c("cum.ppde.p","ppde.p","ROC.x","ROC.y")
        objBayes<-data.frame(objBayes, ppdeVal)
    }
    
    ## Multtest if wanted
    if (doMulttest){
        objBayes <- data.frame(objBayes, runMulttest(pVal))
    }
    
    return(objBayes)
}

################################################################################
## Helper functions for the tstat calculations
################################################################################
tstat <- function (sumStats)
{
    ##number of replicates, means and std deviations
    n1=sumStats[1];  n2=sumStats[2]
    m1=sumStats[3];  m2=sumStats[4]
    sd1=sumStats[5]; sd2=sumStats[6]
    ##  do the two sample t-test
    tt <- -(m1 - m2)/sqrt((((n1 - 1) * sd1^2 + (n2 - 1) * sd2^2)/(n1 +
    n2 - 2)) * ((n1 + n2)/(n1 * n2)))
    dft <- n1 + n2 - 2
    rvar <- max((sd1^2)/(sd2^2), (sd2^2)/(sd1^2))
    as.vector(c(tt, dft, rvar))
}


runavg <- function(x,k=1) {
    ## x is the input vector
    ## n is the length of the vector
    ## k is the size of the running average window, the window
    ##   includes the data point at that position plus k points
    ##   on either side.  For example k = 3 would be a sliding
    ##   window of size {3+1+3}= 7 centered on each point
    ## r is the output vector
    if (k <= 0)
    stop("Error: Window size (k) must be greater than zero")
    x<-as.array(x);
    n <- length(x)
    if (k >= n){
        msg <- 'Window Size must be less than number of data points!'
        writeError(msg)
        stop(msg)
    }
    
    r<-0
    t<-0
    
    for (j in 0:k) {
        t<-t+x[j+1]
    }
    
    l=0
    u=k
    
    for (i in 0:(n-1)) {
        ## the use of u-l-1 instead of k handles end effects
        r[i+1]= (t/(u-l+1))
        ## update the current running total for the next position
        if (i > k-1) {
            t=t-x[l+1]
            l=l+1
        }
        if (u < n-1) {
            u=u+1
            t=t+x[u+1]
        }
    }
    
    return(as.array(r))
}

runavgPool <- function(x,k=1) {
    ## x is the input vector
    ## n is the length of the vector
    ## k is the size of the running average window, the window
    ##   includes the data point at that position plus k points
    ##   on either side.  For example k = 3 would be a sliding
    ##   window of size {3+1+3}= 7 centered on each point
    ## r is the output vector
    if (k <= 0)
    stop("Error: Window size (k) must be greater than zero")
    
    x <- as.matrix(x);
    n <- dim(x)[1]
    
    r<-0
    t<-0
    
    side <- (k-1)/2
    
    for (j in 1:side) {
        flatArr <- NULL
        for(i in 1:(j+side))
        flatArr <- c(flatArr,x[i,])
        
        flatArr<-as.array(flatArr)
        
        r[j]<-sd(flatArr)
    }
    for (j in (side+1):(n-(side+1))) {
        flatArr <- NULL
        for (i in (j-side):(j+side))
        flatArr <- c(flatArr,x[i,])
        flatArr<-as.array(flatArr)
        r[j]<-sd(flatArr)
        
    }
    for (j in (n-side):n) {
        flatArr <- NULL
        for(i in (j-side):n)
        flatArr <- c(flatArr,x[i,])
        flatArr<-as.array(flatArr)
        r[j]<-sd(flatArr)
    }
    return(as.array(r))
}

secMin<-function(a){
    ##returns the next minimum after the overall min
    i=0
    a<-sort(a)
    secondMin=a[1]
    while (secondMin==a[1]){
        i=i+1
        secondMin=a[i]
    }
    return(secondMin)
}

secMax<-function(a){
    ##returns the next maximum after the overall max
    i=0
    a<-sort(a,decreasing=TRUE)
    secondMax=a[1]
    if (all(a == secondMax)){
        return(NA)
    }
    while (secondMax==a[1]){
        i=i+1
        secondMax=a[i]
    }
    return(secondMax)
}


adjPVal<-function(a){
    ##makes sure that p-values are not zero but some very small value (factor of 10 smaller than second min)
    ##also if p-values are 1, then they are made a very small number less than 1 but more than all others
    if(min(a)==0){
        if (all(a == 0)){a[a==0] = 0.0000000001;  return(a)}
        adj<-secMin(a)/10
        a[a==0]=adj
    }
    if(max(a)==1){
        if (all(a == 1)){a[a==1] = 0.999999999;  return(a)}
        
        adj<-secMax(a) + ((1-secMax(a))*9/10)
        a[a==1]=adj
    }
    return(a)
}


################################################################################
## cyberTPlots
## Make some simple plots for the webserver
## resData - has normalized data, pVals, ROC vals
## rawData - has original data sent in.
## Make the following plots:
## Mean Control Vs Mean Experimental, raw and norm
## Mean vs Variance, raw and norm, mean and control
## p-value associated with rawScores (fold change (or mean diff))
## ROC Plot (if given)
## Some plots only make sense for CE or paired, so take what we can.
## Assumes that the dataframes are lined up! And dfs are in format:
##  Controls, Experiments, Results
## And resData - has normalized data
##
## 4-8-12 - Add in smoothing and outlier removal options
## 1-25-12 - Make so write out each in different png files for display on web
##
################################################################################
cyberTPlots <- function(resData, rawData, numC=0, numE=0, numR=0, repPerCond=NULL, dataType='CE', normType='None',
doSmoothing=TRUE, doOutlierRemoval=TRUE, outputFmt='png', doTitle=TRUE){
    .libPaths("/home/baldig/shared_libraries/centos64/pkgs/R/2.15.1_fix/lib64/R/library")
    library(lattice)
    library(geneplotter)
    
    #fileNameFmt <- sprintf('%%s.%s', outputFmt)
    fileNameFmt <- outputFmt
    graphicsFunc <- png
    if (outputFmt == 'ps'){
        graphicsFunc <- postscript
    }
    
    mainFunc <- function(title){
        if (doTitle){
            return(title)
        }
        NULL
    }
    
    ## Setup functions for smoothing and outlier removal
    smoothingPanelFunc <- function(...){panel.smoothScatter(nbin=128, ...)}
    outlierRows <- function(x){
        qnt <- quantile(x, probs=c(.25, .75), na.rm=TRUE)
        h <- 2.0 * IQR(x, na.rm=TRUE)
        is.na(x) | is.nan(x) | (x < (qnt[1] - h)) | (x > (qnt[2] + h))
    }
    outlierRows.2d <- function(x,y){
        outlierRows(x) | outlierRows(y)
    }
    outlierRows.splom <- function(d){
        alld <- as.vector(unlist(d))
        qnt <- quantile(alld, probs=c(.25, .75), na.rm=TRUE)
        h <- 2.0 * IQR(alld, na.rm=TRUE)
        outDF <- is.na(d) | (d < qnt[1] - h) | (d > qnt[2] + h)
        apply(outDF, 1, any)
    }
    
    panelFunc <- panel.xyplot #lattice.getOption("panel.xyplot")
    splomPanelFunc <- panel.splom #lattice.getOption("panel.splom")
    outlierFunc <- function(...){FALSE}
    outlierSplomFunc <- function(...){FALSE}
    if (doSmoothing){
        panelFunc <- smoothingPanelFunc
        splomPanelFunc <- smoothingPanelFunc
    }
    if (doOutlierRemoval){
        outlierFunc <- outlierRows.2d
        outlierSplomFunc <- outlierRows.splom
    }
    
    getPanelFunc <- function(){
        return(panelFunc)
    }
    
    cCols <- c(1:numC)
    eCols <- c((numC+1):(numC+numE))
    rCols <- c(1:numR)
    
    bayes <- FALSE
    if (dataType == 'CE'){
        ## Setup the data to plot
        if (normType == 'None'){
            toPlot <- data.frame(type=factor(rep(c('Cond1', 'Cond2'), each=nrow(rawData))),
            rawmean=c(resData$meanC, resData$meanE),
            rawsd=c(resData$stdC, resData$stdE),
            normmean=c(resData$meanC, resData$meanE),
            normsd=c(resData$stdC, resData$stdE)
            )
            rawMeans <- data.frame(C1=resData$meanC, C2=resData$meanE)
        } else if (normType != 'None'){
            toPlot <- data.frame(type=factor(rep(c('Cond1', 'Cond2'), each=nrow(rawData))),
            rawmean=c(apply(rawData[,cCols], 1, mean), apply(rawData[,eCols], 1, mean)),
            rawsd=c(apply(rawData[,cCols], 1, sd), apply(rawData[,eCols], 1, sd)),
            normmean=c(resData$meanC, resData$meanE),
            normsd=c(resData$stdC, resData$stdE))
            rawMeans <- data.frame(C1=apply(rawData[,cCols], 1, mean), C2=apply(rawData[,eCols], 1, mean))
        }
        if (length(grep('bayes', colnames(resData))) > 0){
            toPlot <- data.frame(toPlot,
            bayessd=c(resData$bayesSDC, resData$bayesSDE))
            bayes <- TRUE;
        }
        
        ## Start with some plots
        ## Means of different conditions
        graphicsFunc(sprintf('ce_raw_plot.%s', fileNameFmt))
        print(xyplot(C2 ~ C1, rawMeans, xlab = "Mean Conditon 1 Raw Intensity", ylab = "Mean Condition 2 Raw Intensity",
        main = mainFunc("Raw Intensity Comparison"),
        panel=panelFunc, subset=!outlierFunc(rawMeans$C1, rawMeans$C2)))
        graphics.off()
        
        if (normType != 'None'){
            normMeans <- data.frame(C1=resData$meanC, C2=resData$meanE)
            graphicsFunc(sprintf('ce_norm_plot.%s', fileNameFmt))
            xlab <- sprintf("Mean Condition 1 %s-transformed Intensity", normType)
            ylab <- sprintf("Mean Condition 2 %s-transformed Intensity", normType)
            print(xyplot(C2 ~ C1, normMeans,
            xlab = xlab, ylab = ylab,
            main = mainFunc(sprintf("Normalized Intensity Comparison", normType)),
            panel=panelFunc, subset=!outlierFunc(normMeans$C1, normMeans$C2)))
            graphics.off()
        }
        
        ## Means vs sds
        ## Only if Norm is not None or no bayes
        ## if norm is None and bayes, then this is included in the bayes plot below.
        if (normType != 'None' || ! bayes)
        {
            graphicsFunc(sprintf('sdmean_raw_plot.%s', fileNameFmt))
            print(xyplot(rawsd ~ rawmean | type, toPlot, xlab = "Mean Raw Intensity",
            ylab = "Empirical Standard Deviation ",
            main = mainFunc("Raw Mean/Empirical Variance Dependence"),
            panel=panelFunc, subset=!outlierFunc(toPlot$rawsd, toPlot$rawmean)))
            graphics.off()
        }
        
        ## And for the next, only plot if no bayes.
        ## If there is bayes, then we will have included in another plot.
        if (normType != 'None' && !bayes)
        {
            graphicsFunc(sprintf('sdmean_norm_plot.%s', fileNameFmt))
            xlab <- sprintf("Mean %s-transformed Intensity", normType)
            print(xyplot(normsd ~ normmean | type, toPlot,
            xlab = xlab,
            ylab = "Empirical Standard Deviation",
            main = mainFunc(sprintf("%s-transformed Mean/Empirical Variance Dependence", normType)),
            pch="*", panel=panelFunc, subset=!outlierFunc(toPlot$normsd, toPlot$normmean)))
            graphics.off()
        }
        
        if (bayes){
            ## Plot mean vs bayessd  - Actually, this is in the plot lower down
            #graphicsFunc(sprintf('bayessdmean_norm_plot.%s', fileNameFmt))
            #xlab <- "Mean Raw Intensity"
            #main <- "Raw Mean/Bayes-regularized Variance Dependence"
            #if (normType != 'None'){
            #  xlab <- sprintf("Mean %s-transformed Intensity", normType)
            #  main <- sprintf("%s-transformed Mean/Bayes-regularized Variance Dependence", normType)
            #}
            #print(xyplot(bayessd ~ normmean| type, toPlot, ylab='Bayes-regularized Standard Deviation',
            #             xlab=xlab,
            #             main=main
            #             ))
            #graphics.off()
            
            ## Plot empirical vs bayes sds
            graphicsFunc(sprintf('bayesvempsd_norm_plot.%s', fileNameFmt))
            main <- mainFunc("Raw Data Regularization Effect")
            if (normType != 'None'){
                main <- sprintf("%s-transformed Data Regularization Effect", normType)
            }
            print(xyplot(bayessd ~ normsd |type, toPlot, xlab='Empirical Standard Deviation',
            ylab='Bayes-regularized Standard Deviation',
            main=main ,
            panel = function(...) {
                panelFunc(...);
                panel.abline(a = c(0, 1), lty = 2);
            }, subset=!outlierFunc(toPlot$bayessd, toPlot$normsd)))
            graphics.off()
            
            ## Plot of mean vs std devs for norm data, both bayes and empirical
            typeVect <- c(levels(toPlot$type)[toPlot$type], levels(toPlot$type)[toPlot$type])
            ## And then add in a plot where we look at the mean vs std for bayes/non bayes
            nToPlot <- data.frame(mean=c(toPlot$normmean, toPlot$normmean),
            sd=c(toPlot$normsd, toPlot$bayessd),
            sdtype=rep(c('Empirical', 'Bayes-regularized'), each=nrow(toPlot)),
            type=typeVect)
            xlab <- "Mean Raw Intensity"
            main <- mainFunc("Effect of regularization - Mean/Variance Dependence")
            if (normType != 'None'){
                xlab <- sprintf("Mean %s-transformed Intensity", normType)
            }
            graphicsFunc(sprintf('bayesandempsd_vs_mean_plot.%s', fileNameFmt))
            print(xyplot(sd~ mean | sdtype + type, nToPlot, xlab=xlab,
            ylab="Standard Deviation", main=main,
            panel=panelFunc,
            subset=!outlierFunc(nToPlot$sd, nToPlot$mean)))
            graphics.off()
            
        }
    }
    if (dataType == 'P'){
        if (normType == 'None'){
            toPlot <- data.frame(rawmean=resData$meanR,
            rawsd=resData$stdR,
            normmean=resData$meanR,
            normsd=resData$stdR
            )
        } else if (normType != 'None'){
            toPlot <- data.frame(rawmean=apply(rawData[,rCols], 1, mean),
            rawsd=apply(rawData[,rCols], 1, sd),
            normmean=resData$meanR,
            normsd=resData$stdR)
        }
        if (length(grep('bayes', colnames(resData))) > 0){
            toPlot <- data.frame(toPlot,
            bayessd=resData$bayesSD)
            bayes <- TRUE;
        }
        if (normType != 'None' || ! bayes)
        {
            graphicsFunc(sprintf('sdmean_raw_plot.%s', fileNameFmt))
            print(xyplot(rawsd ~ rawmean, toPlot, xlab = "Raw Mean Difference", ylab = "Empirical Standard Deviation",
            main = mainFunc("Raw Mean Difference/Empirical Variance Dependence"), panel=panelFunc,
            subset=!outlierFunc(toPlot$rawsd, toPlot$rawmean)))
            graphics.off()
        }
        if (normType != 'None' && ! bayes){
            graphicsFunc(sprintf('sdmean_norm_plot.%s', fileNameFmt))
            xlab <- sprintf("Mean %s-transformed Difference", normType)
            print(xyplot(normsd ~ normmean, toPlot, xlab = xlab, ylab = "Empirical Standard Deviation",
            main = mainFunc(sprintf("%s-transformed Mean Difference/Empirical Variance Dependence",
            normType)), panel=panelFunc, subset=!outlierFunc(toPlot$normsd, toPlot$normmean)))
            graphics.off()
        }
        if (bayes){
            ## graphicsFunc(sprintf('bayessdmean_norm_plot.%s', fileNameFmt))
            ## xlab <- "Raw Mean Differences"
            ## main <- "Raw Mean Difference/Bayes-regularized Variance Dependence"
            ## if (normType != 'None'){
            ##   xlab <- sprintf("Mean %s-transformed Difference", normType)
            ##   main <- sprintf("%s-transformed Mean/Bayes-regularized Variance Dependence", normType)
            ## }
            ## print(xyplot(bayessd ~ normmean, toPlot, ylab='Bayes-regularized Standard Deviation',
            ##              xlab=xlab,
            ##              main=main
            ##              ))
            ## graphics.off()
            graphicsFunc(sprintf('bayesvempsd_norm_plot.%s', fileNameFmt))
            main <- mainFunc("Raw Data Regularization Effect")
            if (normType != 'None'){
                main <- mainFunc(sprintf("%s-transformed Data Regularization Effect", normType))
            }
            print(xyplot(bayessd ~ normsd , toPlot, xlab='Empirical Standard Deviation',
            ylab='Bayes-regularized Standard Deviation',
            main=main,
            panel = function(...) {
                panelFunc(...);
                panel.abline(a = c(0, 1), lty = 2);
            }, subset=!outlierFunc(toPlot$bayessd, toPlot$normsd)))
            graphics.off()
            
            ## Combining the above :
            #typeVect <- c(levels(toPlot$type)[toPlot$type], levels(toPlot$type)[toPlot$type])
            ## And then add in a plot where we look at the mean vs std for bayes/non bayes
            nToPlot <- data.frame(mean=c(toPlot$normmean, toPlot$normmean),
            sd=c(toPlot$normsd, toPlot$bayessd),
            sdtype=rep(c('Empirical', 'Bayes-regularized'), each=nrow(toPlot))
            )
            #type=typeVect)
            xlab <- "Mean Raw Differences"
            main <- mainFunc("Effect of regularization - Mean/Variance Dependence")
            if (normType != 'None'){
                xlab <- sprintf("Mean %s-transformed Differences", normType)
            }
            graphicsFunc(sprintf('bayesandempsd_vs_mean_plot.%s', fileNameFmt))
            print(xyplot(sd~ mean | sdtype , nToPlot, xlab=xlab,
            ylab="Standard Deviation", main=main,
            panel=panelFunc, subset=!outlierFunc(nToPlot$sd, nToPlot$mean)))
            graphics.off()
            
        }
    }
    if (dataType == 'ANOVA'){
        ## Setup the data to plot
        extractData <- function(nameFmt){
            res <- c()
            for (i in 1:length(repPerCond)){
                colName <- sprintf(nameFmt, i)
                res <- c(res, resData[[colName]])
            }
            res
        }
        if (normType == 'None'){
            toPlot <- data.frame(type=factor(rep(c(sprintf('C%d', 1:length(repPerCond))), each=nrow(rawData))),
            rawmean=extractData('Mean%d'),
            rawsd=extractData('SD%d'))
            toPlot <- data.frame(toPlot,
            normmean=toPlot$rawmean,
            normsd=toPlot$rawsd
            )
            rawMeans <- resData[, grep('Mean', colnames(resData))]
        } else if (normType != 'None'){
            toPlot <- data.frame(type=factor(rep(c(sprintf('C%d', 1:length(repPerCond))), each=nrow(rawData))),
            normmean=extractData('Mean%d'),
            normsd=extractData('SD%d'))
            
            colEnds <- cumsum(repPerCond)
            colStarts <- colEnds - repPerCond + 1
            ## cat('colStarts: ', colStarts, ', colEnds: ', colEnds, '\n')
            
            rawMeans <- matrix(NA, nrow=nrow(rawData), ncol=length(repPerCond))
            rawSds <- matrix(NA, nrow=nrow(rawData), ncol=length(repPerCond))
            
            for (i in 1:length(repPerCond)){
                if (repPerCond[i] == 1){
                    rawMeans[, i] <- rawData[,colStarts[i]]
                    rawSds[, i] <- 0
                } else {
                    rawMeans[, i] <- apply(rawData[,colStarts[i]:colEnds[i]], 1, mean)
                    rawSds[, i] <- apply(rawData[,colStarts[i]:colEnds[i]], 1, sd)
                }
            }
            rawMeans <- data.frame(rawMeans)
            colnames(rawMeans) <- sprintf('C%d', 1:length(repPerCond))
            rawSds <- data.frame(rawSds)
            colnames(rawSds) <- sprintf('C%d', 1:length(repPerCond))
            
            toPlot <- data.frame(toPlot,
            rawmean=as.vector(unlist(rawMeans)),
            rawsd=as.vector(unlist(rawSds))
            )
        }
        if (length(grep('bayes', colnames(resData))) > 0){
            toPlot <- data.frame(toPlot,
            bayessd=extractData('bayesSD%d'))
            bayes <- TRUE;
        }
        ## Start with some plots
        ## Means of different conditions
        cat('About to print first splom!\n')
        cat('Dim(rawMeans)', dim(rawMeans), '\n')
        toPlotSplom <- rawMeans[!outlierSplomFunc(rawMeans),]
        cat('Dim(toPlot)', dim(toPlot), '\n')
        cat(sprintf('%s', head(toPlot)), '\n')
        graphicsFunc(sprintf('anova_raw_plot.%s', fileNameFmt))
        print(splom(toPlotSplom,
        main = mainFunc("Raw Intensity Comparison"),
        panel=splomPanelFunc))
        graphics.off()
        
        if (normType != 'None'){
            normMeans <- resData[, grep('Mean', colnames(resData))]
            cat('About to print second splom!\n')
            toPlotSplom <- normMeans[!outlierSplomFunc(normMeans),]
            cat(sprintf('%s', head(toPlot)), '\n')
            graphicsFunc(sprintf('anova_norm_plot.%s', fileNameFmt))
            print(splom(toPlotSplom,
            main = mainFunc(sprintf("%s-transformed Intensity Comparison", normType)),
            panel=splomPanelFunc))
            graphics.off()
        }
        
        ## Means vs sds - Only if Norm or no bayes
        if (normType != 'None' || ! bayes)
        {
            if (!any(is.na(toPlot$rawsd))){
                cat('About to print sdmean_raw_plot.!\n')
                graphicsFunc(sprintf('sdmean_raw_plot.%s', fileNameFmt))
                print(xyplot(rawsd ~ rawmean | type, toPlot, xlab = "Mean Raw Intensity ", ylab = "Empirical Standard Deviation",
                main = mainFunc("Raw Mean/Empirical Variance Dependence"), panel=panelFunc,
                subset=!outlierFunc(toPlot$rawsd, toPlot$rawmean)))
                graphics.off()
            }
        }
        if (normType != 'None' && ! bayes){
            if (!any(is.na(toPlot$normsd))){
                cat('About to sdmean_norm_plot.!\n')
                graphicsFunc(sprintf('sdmean_norm_plot.%s', fileNameFmt))
                xlab <- sprintf("Mean %s-transformed Intensity", normType)
                print(xyplot(normsd ~ normmean | type, toPlot,
                xlab = xlab, ylab = "Empirical Standard Deviation",
                main = mainFunc(sprintf("%s-transformed Mean/Empirical Variance Dependence",
                normType)),
                pch="*", panel=panelFunc,
                subset=!outlierFunc(toPlot$normsd, toPlot$normmean)))
                graphics.off()
            }
        }
        
        if (bayes){
            ## graphicsFunc(sprintf('bayessdmean_norm_plot.%s', fileNameFmt))
            ## xlab <- "Mean Raw Intensity"
            ## main <- "Raw Mean/Bayes-regularized Dependence"
            ## if (normType != 'None'){
            ##   xlab <- sprintf("Mean %s-transformed Intensity", normType)
            ##   main <- sprintf("%s-transformed Mean/Bayes-regularized Dependence", normType)
            ## }
            ## print(xyplot(bayessd ~ normmean| type, toPlot, ylab='Bayes-regularized Standard Deviation',
            ##              xlab=xlab,
            ##              main=main))
            ## graphics.off()
            if (!any(is.na(toPlot$normsd))){
                cat('About to print bayessdmean_norm_plot..!\n')
                cat(sprintf('toPlot Head : %s', head(toPlot)), '\n')
                cat(sprintf('toPlot Dim : %s', dim(toPlot)), '\n')
                cat(sprintf('toPlot colnames : %s', colnames(toPlot)), '\n')
                graphicsFunc(sprintf('bayesvempsd_norm_plot.%s', fileNameFmt))
                main <- mainFunc("Raw Data Regularization Effect")
                if (normType != 'None'){
                    main <- mainFunc(sprintf("%s-transformed Data Regularization Effect", normType))
                }
                print(xyplot(bayessd ~ normsd |type, toPlot, xlab='Empirical Standard Deviation',
                ylab='Bayes-regularization Standard Deviation',
                main=main,
                panel = function(...) {
                    getPanelFunc()(...);
                    panel.abline(a = c(0, 1), lty = 2);
                }, subset=!outlierFunc(toPlot$bayessd, toPlot$normsd)))
                graphics.off()
                
                ## Combine the above two:
                typeVect <- c(levels(toPlot$type)[toPlot$type], levels(toPlot$type)[toPlot$type])
                ## And then add in a plot where we look at the mean vs std for bayes/non bayes
                nToPlot <- data.frame(mean=c(toPlot$normmean, toPlot$normmean),
                sd=c(toPlot$normsd, toPlot$bayessd),
                sdtype=rep(c('Empirical', 'Bayes-regularized'), each=nrow(toPlot)),
                type=typeVect)
                xlab <- "Mean Raw Intensity"
                main <- mainFunc("Effect of regularization - Mean/Variance Dependence")
                if (normType != 'None'){
                    xlab <- sprintf("Mean %s-transformed Intensity", normType)
                }
                cat('About to bayesandempsd_vs_mean_plot.!\n')
                graphicsFunc(sprintf('bayesandempsd_vs_mean_plot.%s', fileNameFmt))
                cat(sprintf('getPanelFunc returns : %s \n', head(panelFunc)) )
                print(xyplot(sd~ mean | sdtype + type, nToPlot, xlab=xlab,
                ylab="Standard Deviation", main=main,
                panel=panelFunc, subset=!outlierFunc(nToPlot$sd, nToPlot$mean)))
                graphics.off()
            }
        }
    }
    
    if (! is.null(resData$ROC.x) & ! is.null(resData$ROC.y)){
        rocData <- data.frame(ROC.x=resData$ROC.x, ROC.y=resData$ROC.y)
        cat('About to print roc_plot..!\n')
        graphicsFunc(sprintf('roc_plot.%s', fileNameFmt))
        print(xyplot(ROC.y ~ ROC.x, rocData, xlab = "False Positive Rate [FP/(FP+TN)]",
        ylab = "True Positive Rate [TP/(TP+FN)]",
        main = mainFunc("Receiver Operating Characteristic (ROC) Curve")))
        graphics.off()
        write.table(rocData, file='ROC.txt', sep='\t', col.names=T, row.names=F)
    }
    graphics.off()
}

################################################################################
#### One-Way ANOVA Code #####
## runAllBayesAnova - wrapper to do everything for the ANOVA analysis
################################################################################
runAllBayesAnova <- function(aData, numVec, bayes=1, winSize=101, conf=10, ppde=1, betaFit=1,
doMulttest=FALSE, bayesIntAnova=FALSE, doPostHoc=FALSE, postHocType="T"){
    ## Method to run all parts of the ANOVA analysis;
    ## From the actual bayesAnova calls to doing ppde, mult hyp testing, and post-hoc tests
    aovRes <- bayesAnova(aData, numVec, bayes, winSize, conf, bayesIntAnova);
    if (doPostHoc){
        postHocData <- postHoc(aovRes, numVec, postHocType, bayes)
        aovRes <- data.frame(aovRes, postHocData)
    }
    if (ppde){
        ppdeData <- ppdeMix(as.matrix(aovRes$pVal), betaFit)
        aovRes <- data.frame(aovRes, ppdeData)
    }
    if (doMulttest){
        mtData <- runMulttest(aovRes$pVal)
        aovRes <- data.frame(aovRes, mtData)
    }
    aovRes
}

################################################################################
## bayesAnova
##
## adata is organized as: cond1-1,cond1-2,...,condN-1,condN-2,condN-m
## numVec is the number of replicates in each condition e.g. c(3,3,4)
## the number of columns should be the sum of numVec
## ppde, betaFit - ppde parameters
## doMulttest - do multiple testing
## bayesIntAnova - pool the intensities rather than the variances.
################################################################################
bayesAnova<-function(aData,numVec,bayes=1,winSize=101,conf=10, bayesIntAnova=F){
    numGenes <- dim(aData)[1]
    totMeasures <- dim(aData)[2]
    
    if (!(totMeasures==sum(numVec)))
    stop("ERROR: Number of replicates in each condition do not match total number of columns in dataset.")
    if (ceiling((winSize - 1) / 2) != ((winSize - 1) / 2))
    stop("ERROR: winSize must be an odd number.")
    winSize = (winSize - 1) / 2
    
    numCond=dim(as.array(numVec))
    
    ## store nVec, means, standard deviations in arrays
    nVec=matrix(data=NA,nrow=numGenes,ncol=numCond)
    mVec=matrix(data=NA,nrow=numGenes,ncol=numCond)
    sdVec=matrix(data=NA,nrow=numGenes,ncol=numCond)
    cat('numCond: ', numCond, '\n')
    for (i in 1:numCond){
        ##compute number of valid entries for each gene
        cat('The expr : ', (1+sum(numVec[0:(i-1)])):sum(numVec[1:i]), '\n')
        nVec[,i] <- apply(as.matrix(aData[, (1+sum(numVec[0:(i-1)])):sum(numVec[1:i])]),
        1, function(x) sum(!is.na(x)))
        
        ## compute means for valid entries
        mVec[,i] <- apply(as.matrix(aData[, (1+sum(numVec[0:(i-1)])):sum(numVec[1:i])]),
        1, function(x) {
            if (sum(!is.na(x)))
            mean(x[!is.na(x)])
            else NA}
        )
        ## check that at least 2 replicates are present
        sdVec[,i] <- apply(as.matrix(aData[, (1+sum(numVec[0:(i-1)])):sum(numVec[1:i])]),
        1, function(x) {
            if (sum(!is.na(x)) > 1)
            sqrt(var(x[!is.na(x)]))
            else NA}
        )
        colnames(nVec)=paste("Num",1:numCond,sep="")
        colnames(mVec)=paste("Mean",1:numCond,sep="")
        colnames(sdVec)=paste("SD",1:numCond,sep="")
    }
    
    ## Calculate the statistics either in the bayesian or classical way
    if (bayes){
        ## If there is one value or explicitly told so, we should use the intensities
        if (any(numVec == 1)){bayesIntAnova = TRUE}
        
        rasdVec=matrix(data=NA,nrow=numGenes,ncol=numCond)
        colnames(rasdVec)=paste("bayesSD",1:numCond,sep="")
        
        if (!bayesIntAnova){
            ## compute rasd for each condition - using just averages
            ## over sd windows
            for (j in 1:numCond){
                stdC<-sdVec[,j]
                meanC<-mVec[,j]
                nC<-nVec[,j]
                temp <- runavg(stdC[!is.na(stdC)][order(meanC[!is.na(stdC)])],winSize)
                temp <- temp[rank(meanC[!is.na(stdC)])]
                rasdC <- rep(NA, numGenes)
                rasdC[!is.na(stdC)]<- temp
                
                ##compute bayes sd
                rasdVec[,j]<- sqrt((conf * rasdC^2 + (nC - 1) * stdC^2)/(conf + nC - 2))
            }
        } else {
            ## Compute rasd for each condition
            ## Using sd over windows of intensities
            for (j in 1:numCond){
                stdC<-sdVec[,j]
                meanC<-mVec[,j]
                nC<-nVec[,j]
                intMat <- as.matrix(aData[!is.na(meanC), (1+sum(numVec[0:(j-1)])):sum(numVec[1:j])])
                intMat <- intMat[order(meanC[!is.na(meanC)]),]
                temp <- runavgPool(intMat, winSize)
                temp <- temp[rank(meanC[!is.na(meanC)])]
                rasdC <- rep(NA, numGenes)
                rasdC[!is.na(meanC)]<- temp
                
                ## Then make sure that meanC, stdC, and rasdC are all
                ## almost zero (if na)
                stdC[is.na(stdC) & !is.na(rasdC)] <- ALMOST_ZERO
                rasdC[rasdC == 0] <- ALMOST_ZERO
                
                ##compute bayes sd
                rasdVec[,j]<- sqrt((conf * rasdC^2 + (nC - 1) * stdC^2)/(conf + nC - 2))
            }
        }
        
        aovBayes <- matrix(data=NA, nrow=numGenes, ncol=6)
        colnames(aovBayes) <- c("MSE.B", "MSE.W", "Fstat", "dfBetBayes", "dfWithBayes", "pVal")
        for (i in 1:numGenes){
            aovBayes[i,] <- bayesFtest(nVec[i,],
            mVec[i,],
            rasdVec[i,],
            conf=conf,bayes=1)
            if (!is.na(aovBayes[i,3])){
                if (aovBayes[i,3] < 0) aovBayes[i,1:6] <- NA
            }
            else aovBayes[i,1:6] <- NA
        }
        aovBayes <- cbind(aData, nVec, mVec, sdVec, rasdVec, aovBayes)
        rm(nVec,mVec,sdVec,rasdVec)
    }
    else{
        ## Non-bayesian way of calculating
        aovBayes <- matrix(data=NA, nrow=numGenes, ncol=6)
        colnames(aovBayes) <- c("MSE.B", "MSE.W", "Fstat", "dfBet", "dfWith", "pVal")
        for (i in 1:numGenes){
            ## check that at least 2 replicates are present
            ## This must be true for the non-bayesian
            aovBayes[i,] <- bayesFtest(nVec[i,(nVec[i,]>1)],
            mVec[i,(nVec[i,]>1)],
            sdVec[i,(nVec[i,]>1)],
            conf=conf,bayes=0)
            if (!is.na(aovBayes[i,3])){
                if (aovBayes[i,3]<0) aovBayes[i,1:6] <- NA
            }
            else aovBayes[i,1:6] <- NA
        }
        aovBayes <- cbind(aData, nVec, mVec, sdVec, aovBayes)
        rm(nVec, mVec, sdVec)
    }
    return(aovBayes)
}


################################################################################
## Helper function for the ANOVA analysis
##
## Note: To properly handle the one sample case, we need to
## pass in a flag for the bayes
################################################################################
postHoc<-function(aovData, numVec, postTest="T", bayes=FALSE){
    ##postTest: postHoc test to be used, "T"=TukeyHSD, "S"=Scheffe's
    numGenes <- dim(aovData)[1]
    numCond <- dim(as.array(numVec))
    lastCol <- dim(aovData)[2]
    meanCol <- (sum(numVec)+numCond+1):(sum(numVec)+2*numCond)
    numCol <- (sum(numVec)+1):(sum(numVec)+numCond)
    
    ##MSE (Within)
    mseCol <- lastCol-4
    dfBetCol <- lastCol-2
    dfWithCol <- lastCol-1
    
    postHocRes <- matrix(data=NA,nrow=nrow(aovData),ncol=(numCond*(numCond-1)/2))
    print(paste("Note: This analysis may be slow. Performing post-hoc tests for",
    numGenes,"genes in each of the",numCond*(numCond-1)/2,
    "pairwise comparisons.",sep=" "))
    colSt <- NULL
    comparisonNum <- 0
    for (i in 1:numCond)
    for (j in i:numCond)
    if (i!=j){
        print(paste("Performing pairwise comparison",i,"-",j,sep=" "))
        comparisonNum <- comparisonNum+1
        colSt <- c(colSt,paste("Pair",i,"_",j,sep=""))
        if (postTest=="T")
        postHocRes[,comparisonNum] <- tukeyhsd(aovData[,numCol[i]], aovData[,numCol[j]],
        aovData[,meanCol[i]], aovData[,meanCol[j]],
        aovData[,mseCol], aovData[,dfBetCol],
        aovData[,dfWithCol], bayes)
        else if (postTest=="S")
        postHocRes[,comparisonNum] <- scheffes(aovData[,numCol[i]],aovData[,numCol[j]],
        aovData[,meanCol[i]], aovData[,meanCol[j]],
        aovData[,mseCol], aovData[,dfBetCol],
        aovData[,dfWithCol], bayes)
    }
    rownames(postHocRes) <- rownames(aovData)
    colnames(postHocRes) <- colSt
    return(postHocRes)
}


scheffes <- function(nA, nB, mA, mB, MSE, dfBet, dfWith, bayes=FALSE){
    ## If bayes and number of replicates are one.., increase by one.
    if (bayes && nA == 1){nA <- 2}
    if (bayes && nB == 1){nB <- 2}
    S <- NULL
    S <- ((mA - mB)^2) / (MSE * (1 / nA + 1 / nB) * dfBet)
    ##check that at least 2 replicates are present
    S[nA<=1] <- NA
    S[nB<=1] <- NA
    return(1 - pf(S, dfBet, dfWith))
}

tukeyhsd <- function(nA, nB, mA, mB, MSE, dfBet, dfWith, bayes=FALSE){
    if (bayes && nA == 1){nA <- 2}
    if (bayes && nB == 1){nB <- 2}
    ## Warning: When group sizes are unequal, the harmonic mean is used
    hsd <- NULL
    hsd <- abs(mA - mB) / sqrt(MSE / (2 / (1 / nA + 1 / nB)))
    ##check that at least 2 replicates are present
    hsd[nA<=1] <- NA
    hsd[nB<=1] <- NA
    return(1-ptukey(hsd,dfBet+1,dfWith))
}


bayesFtest<-function(nVec,mVec,sdVec,conf,bayes=1){
    ## nVec are numbers of control and expt
    ## mVec are the means resp.
    ## sdVec are the standard deviations resp.
    
    ## Note: if bayes == 1 AND nVec[i] == 1, we need to tweak
    ## the counts in the SS calcs.
    numGps <- dim(as.array(nVec))
    
    ## Calc the total group mean.
    gdMean <- 0
    for (i in 1:numGps)
    gdMean <- gdMean + nVec[i] * mVec[i]
    gdMean <- gdMean / sum(nVec)
    
    ## Calculate the explained (between-group) variance
    betSS <- 0
    for (i in 1:numGps)
    betSS <- betSS + nVec[i] * (mVec[i] - gdMean)^2
    
    ## Note the tweak we put in here if the nVec is 1 (and we are
    ## doing the bayesian analysis)
    withSS <- 0
    for (i in 1:numGps)
    withSS <- withSS + sdVec[i]^2 * (nVec[i] - 1 + (bayes && nVec[i] == 1))
    
    ## Regular ANOVA
    dfBet <- numGps - 1  			 			# k-1
    dfWith <- sum(nVec) - numGps					# k(n-1), n is mean nVec
    
    ## This will only happen if all singletons in the ANOVA.
    if (dfWith < numGps){
        dfWith <- numGps
    }
    
    dfTot <- sum(nVec) - 1					# kn-1
    ## f-statistic is computing on original dfs similar to t-test is computed on original n's
    fstat <- round((betSS / dfBet) / (withSS / dfWith), 4)
    pVal <- 1 - pf(fstat, dfBet, dfWith)
    
    ## Bayes ANOVA (Augmented degres of freedom, taking into account "conf")
    dfBetBayes <- numGps - 1           			        # k-1
    dfWithBayes <- sum(nVec) + numGps * conf - 2 * numGps		# k(n-1+conf-1), n is mean nVec
    dfTotBayes <- sum(nVec) + numGps * conf - numGps - 1		# k(n+(conf-1))-1
    pValBayes <- 1 - pf(fstat, dfBetBayes, dfWithBayes)
    
    if (bayes){
        return(cbind(betSS/dfBet, withSS/dfWith, fstat, dfBetBayes, dfWithBayes, pValBayes))
    }
    else{
        return(cbind(betSS/dfBet, withSS/dfWith, fstat, dfBet, dfWith, pVal))
    }
}


################################################################################
## Code for ppde calculation
################################################################################
ppdeMix <- function(pVal,n){
    ##Implements the method described in Allison et. al.
    ##Computational Statistics & Data Analysis, 39:1-20 (2002)
    
    ## The following objects are suggested objects for input into the mixture fitting
    ## They are lower and upper parameter bounds for the mixture parameters for a one beta,
    ## two beta, and three beta mixture, respectively.  The order of the parameter bounds is
    ## always, lambda0, lambda1, etc, then r1, s1, r2, s2, etc., depending on whether there
    ## are 1, 2, or 3 beta distributions.
    ## Note: beta parameters are capped at 170 since this value in the distribution,
    ## gamma(170) results in Splus reaching infinity limits.
    
    low1 <- c(.001,.01,.01)
    up1 <- c(1,165,165)
    low2 <- c(.001,.001,.01,.01,.01,.01)
    up2 <- c(1,1,165,165,165,165)
    low3 <- c(.001,.001,.001,.01,.01,.01,.01,.01,.01)
    up3 <- c(1,1,1,170,170,170,170,170,170)
    
    ## The following are suggested starting values for the mixture fitting
    ## The starting values are for parameters in the same order as above
    
    p01 <- c(.6,1,4)
    p02 <- c(.9,.5,4,1,1,4)
    p03 <- c(.8,.06,.1,.4,40,.4,55,1,6)
    
    if (ncol(pVal)==2){
        Pdata <- pVal[,2]
        Pdata <- Pdata[!is.na(Pdata)]
    }
    else
    Pdata <- pVal[!is.na(pVal)]
    Pdata<-adjPVal(Pdata)
    
    postP1 <- rep(NA, nrow(pVal))
    postP2 <- rep(NA, nrow(pVal))
    if(n==1){
        parms <- mle.mix(p01,mix.obj1,low1,up1,Pdata)
        L0 <- parms[1]
        L1 <- 1 - parms[1]
        r1 <- parms[2]
        s1 <- parms[3]
        cat("PPDE mixture model parameters\n", file='mix.txt', append=TRUE)
        cat("-----------------------------\n", file='mix.txt', append=TRUE)
        cat(paste("Lambda0 =", round(L0,5), "\n", sep=" "),file='mix.txt', append=TRUE)
        cat(paste("Lambda1 =", round(L1,5), "\n", sep=" "),file='mix.txt', append=TRUE)
        cat(paste("r       =", round(r1,5), "\n", sep=" "),file='mix.txt', append=TRUE)
        cat(paste("s       =", round(s1,5), "\n", sep=" "),file='mix.txt', append=TRUE)
        
        numer1 <- L1 * pbeta(Pdata,r1,s1)
        denom1 <- numer1 + L0 * Pdata
        numer2 <- L1 * dbeta(Pdata,r1,s1)
        denom2 <- numer2 + L0
        
        rocX <- rep(NA, nrow(pVal))
        rocY <- rep(NA, nrow(pVal))
        if (ncol(pVal)==2){
            rocX[!is.na(pVal[,2])]<-Pdata
            rocY[!is.na(pVal[,2])]<-pbeta(Pdata,r1,s1)
        }
        else{
            rocX[!is.na(pVal)]<-Pdata
            rocY[!is.na(pVal)]<-pbeta(Pdata,r1,s1)
        }
    }
    else if(n==2){
        parms <- mle.mix(p02,mix.obj2,low2,up2,Pdata)
        L0 <- parms[1]
        L1 <- parms[2]*(1-parms[1])
        L2 <-(1-parms[1])*(1-parms[2])
        r1 <- parms[3]
        s1 <- parms[4]
        r2 <- parms[5]
        s2 <- parms[6]
        cat("PPDE mixture model parameters\n", file='mix.txt', append=TRUE)
        cat("-----------------------------\n", file='mix.txt', append=TRUE)
        cat(paste("Lambda0 =", round(L0,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("Lambda1 =", round(L1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("Lambda2 =", round(L2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("r1      =", round(r1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("s1      =", round(s1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("r2      =", round(r2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("s2      =", round(s2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        numer1 <- L1 * pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2)
        denom1 <- numer1 + L0 * Pdata
        numer2 <- L1 * dbeta(Pdata,r1,s1) + L2 * dbeta(Pdata,r2,s2)
        denom2 <- numer2 + L0
        
        rocX <- rep(NA, nrow(pVal))
        rocY <- rep(NA, nrow(pVal))
        if (ncol(pVal)==2){
            rocX[!is.na(pVal[,2])]<-Pdata
            rocY[!is.na(pVal[,2])]<-(L1*pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2))/(L1+L2)
        }
        else{
            rocX[!is.na(pVal)]<-Pdata
            rocY[!is.na(pVal)]<-(L1*pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2))/(L1+L2)
        }
    }
    else if(n==3){
        parms <- mle.mix(p03,mix.obj3,low3,up3,Pdata)
        L0 <- parms[1]
        L1 <- parms[2]*(1-parms[1])
        L2 <- parms[3]*(1-parms[1])*(1-parms[2])
        L3 <- (1-parms[3])*(1-parms[1])*(1-parms[2])
        r1 <- parms[4]
        s1 <- parms[5]
        r2 <- parms[6]
        s2 <- parms[7]
        r3 <- parms[8]
        s3 <- parms[9]
        cat("PPDE mixture model parameters\n", file='mix.txt', append=TRUE)
        cat("-----------------------------\n", file='mix.txt', append=TRUE)
        cat(paste("Lambda0 =", round(L0,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("Lambda1 =", round(L1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("Lambda2 =", round(L2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("Lambda3 =", round(L3,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("r1      =", round(r1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("s1      =", round(s1,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("r2      =", round(r2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("s2      =", round(s2,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("r3      =", round(r3,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        cat(paste("s3      =", round(s3,5), "\n", sep=" "), file='mix.txt', append=TRUE)
        numer1 <- L1 * pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2) + L3 * pbeta(Pdata,r3,s3)
        denom1 <- numer1 + L0 * Pdata
        numer2 <- L1 * dbeta(Pdata,r1,s1) + L2 * dbeta(Pdata,r2,s2) + L3 * dbeta(Pdata,r3,s3)
        denom2 <- numer2 + L0
        
        rocX <- rep(NA, nrow(pVal))
        rocY <- rep(NA, nrow(pVal))
        if (ncol(pVal)==2){
            rocX[!is.na(pVal[,2])]<-Pdata
            rocY[!is.na(pVal[,2])]<-(L1*pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2) + L3 *
            pbeta(Pdata,r3,s3))/(L1+L2+L3)
        }
        else{
            rocX[!is.na(pVal)]<-Pdata
            rocY[!is.na(pVal)]<-(L1*pbeta(Pdata,r1,s1) + L2 * pbeta(Pdata,r2,s2) + L3 *
            pbeta(Pdata,r3,s3))/(L1+L2+L3)
        }
    }
    else cat("Error: Must fit 1,2, or 3 beta's (change betaFit)\n")
    if (ncol(pVal)==2){
        postP1[!is.na(pVal[,2])] <- numer1/denom1
        postP2[!is.na(pVal[,2])] <- numer2/denom2
    }
    else{
        postP1[!is.na(pVal)] <- numer1/denom1
        postP2[!is.na(pVal)] <- numer2/denom2
    }
    ##if (n==1)
    postP<- cbind(postP1,postP2,rocX,rocY)
    colnames(postP) <- c("cum.ppde.p","ppde.p","ROC.x","ROC.y")
    ##else
    ##	postP<- cbind(postP1,postP2)
    if (ncol(pVal)==2)
    postP <- cbind(pVal, postP)
    return(postP)
}

mix.obj1 <- function(p,x){
    ## This object is the objective function for a mixture of a uniform
    ## and one beta distribution
    e <- p[1] + (1-p[1])*(gamma(p[2]+p[3])/(gamma(p[2])*gamma(p[3])))*x^(p[2]-1)*(1-x)^(p[3]-1)
    sle <- -sum(log(e))
    sle
}

mix.obj2 <- function(p,x){
    ## This object is the objective function for a mixture of a uniform
    ## and two beta distributions
    e <- p[1] + (p[2]*(1-p[1]))*(gamma(p[3]+p[4])/(gamma(p[3])*gamma(p[4])))*x^(p[3]-1)*(1-x)^(p[4]-1) +
    ((1-p[1])*(1 - p[2]))*(gamma(p[5]+p[6])/(gamma(p[5])*gamma(p[6])))*x^(p[5]-1)*(1-x)^(p[6]-1)
    sle <- -sum(log(e))
    sle
}

mix.obj3 <- function(p,x){
    ## This object is the objective function for a mixture of a uniform
    ## and three beta distributions
    e <- p[1] + (p[2]*(1-p[1]))*(gamma(p[4]+p[5])/(gamma(p[4])*gamma(p[5])))*x^(p[4]-1)*(1-x)^(p[5]-1) +
    (p[3]*(1-p[1])*(1 - p[2]))*(gamma(p[6]+p[7])/(gamma(p[6])*gamma(p[7])))*x^(p[6]-1)*(1-x)^(p[7]-1) +
    ((1-p[3])*(1-p[1])*(1 - p[2]))*(gamma(p[8]+p[9])/(gamma(p[8])*gamma(p[9])))*x^(p[8]-1)*(1-x)^(p[9]-1)
    sle <- -sum(log(e))
    sle
}

mle.mix <- function(init,mix.obj,low,up,Pdata){
    ## This object computes the MLE's for the mixture distribution
    ## Inputs are:
    ## init = starting values for the computations (see p01, p02, p03 above)
    ## mix.obj = is the objective function (i.e., see mix.obj1 etc from above)
    ## low and up are the parameter limits (see low1, up1 etc from above)
    ## Pdata = the p-values.  This should be a single vector of length
    ## equal to the number of genes in the study.
    ## Note: all inputs should be consistent with regards to the number of components
    ## being fitted.  That is, p01 goes with low1, up1, and mix.obj1.
    ## Output:  An object called mix that is the result of the fitting algorithm.
    ## mix$par are the MLE's of parameters in the same order as above objects.
    ## Note: the weighting parameters on mixture components need to be reparametrized
    ## to make sense.
    tryCatch({ mix <- optim(init,mix.obj,lower=low, upper=up, method="L-BFGS-B", x=Pdata);},
    error = function(e){
        cat('****Fatal CyberT ERROR****\n',
        'Unable to fit the PPDE Mixture Model.\n',
        'Try not running the PPDE or increase the confidence/window size.\n',
        '****End Fatal CyberT ERROR****\n')
        stop(e)}
    )
    return(mix$par)
}

## Some PPDE Functions for fitting and analysis:
## Mainly these are some ways to look at different ways of fitting
## 2 beta + 1 uniform distributions.
## 4-14-2012 - Not used in production code, but available to be used
##  from R directly, or incorporated into site at a later date.

plotBetaFromParm <- function(parm){
    ## Given a param vector (as from mle.mix) for 2 beta setup,
    ## plot the pdfs of the two fit betas.
    library(lattice)
    r1 <- parm[3]; s1 <- parm[4]
    r2 <- parm[5]; s2 <- parm[6]
    
    x <- seq(0.001,.999,.01)
    toplot <- data.frame(x=x, b1=dbeta(x, r1, s1), b2=dbeta(x, r2, s2) )
    xyplot(b1 + b2 ~ x, toplot, type='l',
    par.setting=list(superpose.line=list(col=c('red', 'blue'))),
    auto.key=list(points=F, lines=T, corner=c(0.2, .6), size=3))
}

dgamma <- function(x){
    ## Derivative of gamma function at x:
    digamma(x)*gamma(x)
}

## dbeta.a, dbeta.b - partial derivs of beta function for a,b
dbeta.a <- function(a, b){
    (gamma(a + b)*gamma(b)*dgamma(a) - gamma(a)*gamma(b)*dgamma(a + b))/(gamma(a + b))^2
}
dbeta.b <- function(a, b){
    (gamma(a + b)*dgamma(b)*gamma(a) - gamma(a)*gamma(b)*dgamma(a + b))/(gamma(a + b))^2
}

em.mle.mix.2beta <- function(init,low,up,pdata){
    ## Alternative way to fit the two beta scheme using Expectation Maximization.
    ##
    
    piparams <- init[1:2]
    ## 1 - (sum(piparams)) <- second beta weight
    
    thetaparams <- init[-c(1:2)]
    theta.low <- low[-c(1:2)]
    theta.up <- up[-c(1:2)]
    
    ## Now make a matrix of weights for each data point
    weights <- matrix(rep(c(piparams[1], piparams[2], (1- piparams[1] - piparams[2])),
    each=length(pdata)), nrow=length(pdata))
    
    updateWeights <- function(w, thetas){
        ## E-Step - given some thetas, update the weights.
        ## This is analytic, so simple
        w[, 1] <- 1
        w[, 2] <- dbeta(pdata, thetas[1], thetas[2])
        w[, 3] <- dbeta(pdata, thetas[3], thetas[4])
        sw <- apply(w, 1, sum)
        w <- w/sw
        w
    }
    
    objFunc <- function(thetas, w){
        ## Expected complete-data log-likelihood (to optimize in M-step)
        ## Calc the beta vals, but give a little weight to
        b1 <- dbeta(pdata, thetas[1], thetas[2])
        b1[b1 < .Machine$double.eps] <- .Machine$double.eps
        b2 <- dbeta(pdata, thetas[3], thetas[4])
        b2[b2 < .Machine$double.eps] <- .Machine$double.eps
        
        r <- w[,2] * log(b1) +
        w[, 3] * log(b2)
        -sum(r)
    }
    d.objFunc <- function(p, w){
        ## Can break this down per theta
        a1 <- w[, 2] * (-dbeta.a(p[1], p[2])/beta(p[1], p[2]) +
        log(pdata))
        b1 <- w[, 2] * (-dbeta.b(p[1], p[2])/beta(p[1], p[2]) +
        log(1-pdata))
        a2 <- w[, 3] * (-dbeta.a(p[3], p[4])/beta(p[3], p[4]) +
        log(pdata))
        b2 <- w[, 3] * (-dbeta.b(p[3], p[4])/beta(p[3], p[4]) +
        log(1-pdata))
        a1 <- -sum(a1)
        b1 <- -sum(b1)
        a2 <- -sum(a2)
        b2 <- -sum(b2)
        
        ## Getting some strange infinite sized steps, cut down
        ##  the gradient calc by a factor of 10
        0.1 * c(a1, b1, a2, b2)
    }
    updateThetas <- function(thetas, weights){
        ## M-Step - given some weights, update the thetas.
        ## This cannot be solved analytically, so have to do some optimization.
        opt <- optim(thetas, objFunc, d.objFunc, lower=theta.low, upper=theta.up,
        method="L-BFGS-B", w=weights)
        opt$par
    }
    
    ## Initial E-Step
    weights <- updateWeights(weights, thetaparams)
    
    minDiff <- 1
    niter <- 0
    while (minDiff > 2*sqrt(.Machine$double.eps)){
        old.thetas <- thetaparams
        old.objVal <- objFunc(thetaparams, weights)
        ## M-Step
        thetaparams <- updateThetas(thetaparams, weights)
        
        ## E-Step
        weights <- updateWeights(weights, thetaparams)
        
        ## for debugging
        niter <- niter + 1
        objVal <- objFunc(thetaparams, weights)
        #cat('At Iter:', niter, ' with objFunc: ', objVal, '\n')
        
        ## calc divergence
        minDiff <- abs(old.objVal - objVal)
        if (niter > 100){
            minDiff <- .Machine$double.eps
        }
    }
    
    final.weights <- updateWeights(weights, thetaparams)
    pivals <- apply(final.weights, 2, sum)/nrow(final.weights)
    
    return( c(pivals[1], pivals[2], thetaparams))
}

################################################################################
## End of ppde section
################################################################################

writeError <- function(msg){
    cat('****Fatal CyberT ERROR****\n',
    msg, '\n',
    '****End Fatal CyberT ERROR****\n')
}




#############

### with simple t-scores (per row) ###

diffScoreMult3_tscore <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        org.tscores[[i]] <- as.numeric(apply(exprdat,1,function(x) t.test(x[1:length(ind1)],x[(length(ind1+1):(length(ind1)+length(ind2)))])$statistic))
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            perm.t[[i]] <- as.numeric(apply(exprdat,1,function(x) t.test(x[1:length(ind1)],x[(length(ind1+1):(length(ind1)+length(ind2)))])$statistic))
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}


##############

diffScoreMult3_wad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- WAD(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- WAD(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}

##################

diffScoreMult3_ad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores[[i]] <- AD(exprdat,data.cl)
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[[i]] <- AD(exprdat,data.cl)
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}



############### with SMVar ...can be used for log ratio too###

diffScoreMult3_SMVar <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    library(SMVar)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat1 <- expr[,ind1]
        geneID <- rownames(expr.data)
        rownames(exprdat1) <- NULL
        exprdat2 <- expr[,ind2]
        rownames(exprdat2) <- NULL
        org.tscores[[i]] <- SMVar.unpaired(geneID,list(exprdat1,exprdat2))[,3]
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat1 <- expr[,ind1]
            geneID <- rownames(expr.data)
            rownames(exprdat1) <- NULL
            exprdat2 <- expr[,ind2]
            rownames(exprdat2) <- NULL
            perm.t[[i]] <- SMVar.unpaired(geneID,list(exprdat1,exprdat2))[,3]
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}


#######################################
#######################################

# with fcros (fold change rank ordering statistics, 2014 Dembele and Kastner BMC Bioinformatics)###

diffScoreMult3_fcros <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        rownames(exprdat) <- rownames(expr.data)
        cont <- colnames(exprdat)[1:length(ind1)]
        test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        log2.opt <- 0
        trim.opt <- 0.2
        org.tscores[[i]] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            rownames(exprdat) <- rownames(expr.data)
            cont <- colnames(exprdat)[1:length(ind1)]
            test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            log2.opt <- 0
            trim.opt <- 0.2
            perm.t[[i]] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}


##############

# with QD (by Petri) method 5 ###

diffScoreMult3_QD <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    perms <- vector("list",perm.number)
    for(j in 1:perm.number){
        lst <- list()
        lbs.org <- lbs
        lbs.ite <- lbs
        prbs <- unlist(lapply(lbs.org, function(x) sample(x, 1, replace=F))) ## vector of one sample from each grps
        lbs.ite <- updateLbs(lbs.ite,prbs)
        resamp <- function(x,...){if(length(x)==1) x else sample(x,...)}
        for(i in 1:length(lbs.org)){
            lbs.ite <- lbs.ite[sapply(lbs.ite, function(x) length(x)[1]) > 0] ##removing empty groups
            grps <- c(1:length(lbs.ite))[-i] ## vector of all the groups except ith group
            grp_sz <- length(lbs.org[[i]])-1 ## size of the grp samples which are to be sampled from grps
            if(length(grps)<grp_sz){
                x <- sample(unlist(lbs.ite),grp_sz,replace=F)
            }
            else{
                grp_ind <- sample(grps, grp_sz, replace=F) ## more groups than sample sz, so no of groups = grp_sz are sampled
                x <- unlist(lapply(lbs.ite[grp_ind],function(y) resamp(y, 1, replace=F)))}
            lst[[i]] <- c(prbs[i], x)
            lbs.ite <- updateLbs(lbs.ite,lst[[i]])
        }
        perms[[j]] <- lst
    }
    perm.designs <- getPointers(perms, labels)
    
    
    org.tscores <- list()
    designnn <- model.matrix(~0 + factor(labels))
    colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
    for(i in 1:length(comparisons)){
        grp.ind <- getNumeric(comparisons[i])
        ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
        ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        rownames(exprdat) <- rownames(expr.data)
        lb <- c(rep(0,length(ind1)),rep(1,length(ind2)))
        org.tscores[[i]] <- QD(exprdat, lb)[,2]
    }
    
    ## Calculation of t-scores for permuted data for given comparisons ##
    perm.tscores <- vector("list",perm.number)
    for(k in 1:perm.number){
        perm.t <- list()
        designnn <- perm.designs[[k]]
        colnames(designnn) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        for(i in 1:length(comparisons)){
            grp.ind <- getNumeric(comparisons[i])
            ind1 <- as.numeric(which(designnn[,grp.ind[1]]==1))
            ind2 <- as.numeric(which(designnn[,grp.ind[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            rownames(exprdat) <- rownames(expr.data)
            lb <- c(rep(0,length(ind1)),rep(1,length(ind2)))
            perm.t[[i]] <- QD(exprdat, lb)[,2]
        }
        perm.tscores[[k]] <- perm.t
    }
    
    tscores.tot <- list()
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- matrix(0,dime2[1],perm.number)
    }
    
    for(j in 1:length(comparisons)){
        for(k in 1:perm.number){
            tscores.tot[[j]][,k] <- perm.tscores[[k]][[j]]
        }
    }
    
    for(i in 1:length(comparisons)){
        tscores.tot[[i]] <- cbind(org.tscores[[i]], tscores.tot[[i]])
    }
    
    for(z in 1:length(comparisons)){
        rownames(tscores.tot[[z]]) <- rownames(expr.data)
        if(length(unique(rownames(tscores.tot[[z]])))<length(rownames(tscores.tot[[z]]))){
            tscores.tot[[z]] <- aggregate(tscores.tot[[z]],by=list(rownames(tscores.tot[[z]])),FUN=mean)
            rownames(tscores.tot[[z]]) <- tscores.tot[[z]][,1]
            tscores.tot[[z]] <- tscores.tot[[z]][,2:dim(tscores.tot[[z]])[2]]
            tscores.tot[[z]][order(match(rownames(tscores.tot[[z]]),rownames(gene.sets))),] ##thapeko
        }
        
        ind <- match(rownames(gene.sets),rownames(tscores.tot[[z]]))
        tscores.tot[[z]] <- tscores.tot[[z]][ind,]
        
    }
    
    
    
    out <- tscores.tot
    
}

#####  ####

QD <- function(expr_data, ind_vec){
    
    dat_sz <- dim(expr_data)
    
    frst_mean <- rowMeans(expr_data[,ind_vec == 1])
    scnd_mean <- rowMeans(expr_data[,ind_vec == 0])
    
    frst_stds <- apply(expr_data[,ind_vec == 1], 1, sd)
    scnd_stds <- apply(expr_data[,ind_vec == 0], 1, sd)
    SD_ref <- frst_stds + scnd_stds
    mean_diff <- frst_mean - scnd_mean
    ind <- which(abs(mean_diff) > SD_ref)
    tmp_mean_vals <- rep(0, dat_sz[1])
    tmp_mean_vals[ind] <- sign(mean_diff[ind]) *
    abs( mean_diff[ind] - SD_ref[ind] )
    
    frst_med <-  apply(expr_data[,ind_vec == 1], 1, quantile)
    scnd_med <-  apply(expr_data[,ind_vec == 0], 1, quantile)
    
    mean_diff <-  frst_mean - scnd_mean
    med_diff  <-  frst_med[3,]  - scnd_med[3,]
    ind_bigger  <- which(mean_diff > 0 & med_diff > 0)
    ind_smaller <- which(mean_diff < 0 & med_diff < 0)
    #print("TASSA")
    #lls()
    # Percentile tests
    
    tmp_prc_vals <- matrix(0, dat_sz[1], 2)
    tmp <- frst_med[1,ind_bigger] - scnd_med[5, ind_bigger]
    tmp[tmp < 0] <- 0                # Need tmp for this step!!
    tmp_prc_vals[ind_bigger,1] <- tmp
    
    tmp <- frst_med[2, ind_bigger] - scnd_med[4, ind_bigger]
    tmp[tmp < 0] <- 0
    tmp_prc_vals[ind_bigger,2] <- tmp
    
    #print("PRC Bigger past")
    
    tmp <- frst_med[5, ind_smaller] - scnd_med[1, ind_smaller]
    tmp[tmp > 0] <- 0
    tmp_prc_vals[ind_smaller,1] <- tmp
    
    tmp <- frst_med[4, ind_smaller] - scnd_med[2, ind_smaller]
    tmp[tmp > 0] <- 0
    tmp_prc_vals[ind_smaller,2] <- tmp
    
    #print("PRC SMALLER past")
    
    if(FALSE){
        tmp_mean_vals <- rep(0, dat_sz[1])
        # mean based tests
        tmp <- frst_mean[ind_bigger] - frst_stds[ind_bigger]
        - scnd_mean[ind_bigger] - scnd_stds[ind_bigger]
        tmp[tmp < 0] <- 0
        tmp_mean_vals[ind_bigger] <- tmp
        
        tmp <- frst_mean[ind_smaller] + frst_stds[ind_smaller]
        - scnd_mean[ind_smaller] + scnd_stds[ind_smaller]
        tmp[tmp > 0] <- 0
        tmp_mean_vals[ind_smaller] <- tmp
    } #IF(FALSE)
    
    output <- cbind(tmp_prc_vals, tmp_mean_vals)
    colnames(output) <- c("Min-Max-Diff", "25-75-Diff", "Mean-SD Mean-SD diff")
    output
    
}


##############

diffScoreMult44_limma <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of t-scores for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        mySet <- new("ExpressionSet",expr=as.matrix(expr))
        fit1 <- lmFit(mySet, design)
        cont.matrix <- makeContrasts(contrasts=comparisons[c],levels=design)
        fit2 <- contrasts.fit(fit1, cont.matrix)
        fit2 <- eBayes(fit2)
        org.tscores <- fit2$t
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            mySet <- new("ExpressionSet",expr=as.matrix(expr))
            fit1 <- lmFit(mySet, des)
            cont.matrix <- makeContrasts(contrasts=comparisons[c],levels=des)
            fit2 <- contrasts.fit(fit1, cont.matrix)
            fit2 <- eBayes(fit2)
            perm.t[,k] <- fit2$t
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}

##############

diffScoreMult44_wad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- WAD(exprdat,data.cl)
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- WAD(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}

####################################################################################

diffScoreMult44_ad <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- AD(exprdat,data.cl)
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- AD(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}


#################################################################################

####################################################################################

diffScoreMult44_fc <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        org.tscores <- FC(exprdat,data.cl)
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            data.cl <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            perm.t[,k] <- FC(exprdat,data.cl)
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}


###################################################################################

####################################################################################

diffScoreMult44_fcros <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        rownames(exprdat) <- rownames(expr.data)
        
        cont <- colnames(exprdat)[1:length(ind1)]
        test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
        
        log2.opt <- 0
        trim.opt <- 0.2
    
        org.tscores <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            
            
            rownames(exprdat) <- rownames(expr.data)
            
            cont <- colnames(exprdat)[1:length(ind1)]
            test <- colnames(exprdat)[(length(ind1)+1):(length(ind1)+length(ind2))]
            
            log2.opt <- 0
            trim.opt <- 0.2
        
            perm.t[,k] <- fcros(exprdat, cont, test, log2.opt, trim.opt)$FC2
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}


####################################################################################
diffScoreMult44_cyberT <- function(expr.data, gene.sets, labels, comparisons=comparisons, perm.number){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    dime2 <- dim(expr)
    lbs <- list()
    u <- unique(labels)
    for(i in 1:(length(u))){
        lbs[[i]] <- which(labels==u[i])
    }
    total <- list()
    for(c in 1:length(comparisons)){
        m <- gregexpr('[0-9]+',comparisons[c])
        grps <-  as.numeric(unlist(regmatches(comparisons[c],m)))
        grp1 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[1]]]))
        grp2 <- matrix(0,nrow=perm.number,ncol=length(lbs[[grps[2]]]))
        #grp_list <- list()
        for(j in 1:perm.number){
            lst <- list()
            lbs.org <- lbs
            g1 <- c(resamp(unlist(lapply(lbs.org,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[1]]]),replace=F))
            ind <- findInterval(match(g1, unlist(lbs)), cumsum(c(0,sapply(lbs, length)))+1)
            rel_grps <- lbs.org[ind]
            
            trans <- updateLbs(rel_grps,g1)
            g2 <- c(resamp(unlist(lapply(trans,function(x) if(!length(x)==0){resamp(x,1,replace=F)})),length(lbs.org[[grps[2]]]),replace=F))
            grp1[j,] <- g1
            grp2[j,] <- g2
        }
        
        
        
        
        ###### calculation of wad for original data ##########
        design <- model.matrix(~0 + factor(labels))
        colnames(design) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
        ind1 <- as.numeric(which(design[,grps[1]]==1))
        ind2 <- as.numeric(which(design[,grps[2]]==1))
        exprdat <- expr[,c(ind1,ind2)]
        
        res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
        ind <- grep("bayesT",colnames(res))
        org.tscores <- as.numeric(res[,ind])
        
        
        ## Calculation of t-scores for permuted data for given comparisons ##
        perm.t <- matrix(0,nrow=dim(expr.data)[1],ncol=perm.number)
        for(k in 1:perm.number){
            a=list()
            des <- model.matrix(~0 + factor(labels))
            des[,grps[1]] = 0
            des[,grps[2]] = 0
            des[grp1[k,], grps[1]] = 1
            des[grp2[k,], grps[2]] = 1
            colnames(des) <- paste("group",c(1:length(levels(factor(labels)))),sep="")
            ind1 <- as.numeric(which(des[,grps[1]]==1))
            ind2 <- as.numeric(which(des[,grps[2]]==1))
            exprdat <- expr[,c(ind1,ind2)]
            
            res <- bayesT(exprdat,length(ind1),length(ind2),ppde=FALSE)
            ind <- grep("bayesT",colnames(res))
            perm.t[,k] <- as.numeric(res[,ind])
        }
        out <- cbind(org.tscores,perm.t)
        rownames(out) <- rownames(expr.data)
        total[[c]] <- out
    }
    
    return(total)
    
}




######

### QD calculation based on the first option method 6 ###
diffScoreMult1_QD <- function(expr.data, gene.sets, labels, comparisons, perm.number,fc){
    require(limma)
    require(Biobase)
    expr <- expr.data
    rownames(expr) <- NULL
    m <- gregexpr("[0-9]+",comparisons)
    CompGroups <- regmatches(comparisons,m)
    dime2 <- dim(expr)
    tscores.tot <- list()
    QD.tot <- tscores.tot
    #dime <- list()
    
    for(i in 1:length(CompGroups)){
        ## pit is length of compared groups combined
        pit <- length(c(labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])]],labels[labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])]]))
        z <- c(labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][1])])],labels[which(labels==levels(as.factor(labels))[as.numeric(CompGroups[[i]][2])])])
        perms <- replicate(perm.number,sample(z,pit,replace=FALSE))
        
        dime <- dim(perms)
        tscores.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        QD.tot[[i]] <- array(0, c(dime2[1], dime[2] + 1))
        

            
        ## Calculation of FC-scores for original data for a particular comparison ##
        ind1 <- which(labels==CompGroups[[i]][1])
        ind2 <- which(labels==CompGroups[[i]][2])
        expdat <- expr[,c(ind1,ind2)]
        rownames(expdat) <- rownames(expr.data)
        lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
        QD.tot[[i]][,1] <- QD(expdat,lbs)[,2]
            
            
        ## Calculation of FC-scores for permuted data for a particular comparison ##
            
        for(k in 1:dime[2]){
            ind <- which(labels %in% CompGroups[[i]])
            lb <- labels
            lb[ind] <- perms[,k]
            design <- model.matrix(~0+as.factor(lb))
            ind1 <- which(design[,as.numeric(CompGroups[[i]][1])]==1)
            ind2 <- which(design[,as.numeric(CompGroups[[i]][2])]==1)
            expdat <- expr[,c(ind1,ind2)]
            rownames(expdat) <- rownames(expr.data)
            lbs <- c(rep(1,length(ind1)),rep(2,length(ind2)))
            QD.tot[[i]][,k+1] <- QD(expdat,lbs)[,2]
        }
            
        rownames(QD.tot[[i]]) <- rownames(expr.data)
        if(length(unique(rownames(QD.tot[[i]])))<length(rownames(QD.tot[[i]]))){
            QD.tot[[i]] <- aggregate(QD.tot[[i]],by=list(rownames(QD.tot[[i]])),FUN=mean)
            rownames(QD.tot[[i]]) <- QD.tot[[i]][,1]
            QD.tot[[i]] <- QD.tot[[i]][,2:dim(QD.tot[[i]])[2]]
            ind <- match(rownames(gene.sets),rownames(QD.tot[[i]]))
            QD.tot[[i]] <- QD.tot[[i]][ind,]
        }
            
            out <- QD.tot
        
        return(out)
    }
}

##########


###########################################
###  Weighted Average Difference (WAD)  ###
###########################################
WAD <- function(data=NULL, data.cl=NULL){
    x <- data
    cl <- data.cl
    mean1 <- rowMeans(as.matrix(x[, cl==1]))
    mean2 <- rowMeans(as.matrix(x[, cl==2]))
    x_ave <- (mean1 + mean2)/2
    weight <- (x_ave - min(x_ave))/(max(x_ave) - min(x_ave))
    statistic <- (mean2 - mean1)*weight
    return(statistic)
}

##############
## AD is calculated using log signals ## 

AD <- function(data=NULL, data.cl=NULL){
    x <- data
    cl <- data.cl
    mean1 <- rowMeans(as.matrix(x[, cl==1]))
    mean2 <- rowMeans(as.matrix(x[, cl==2]))
    statistic <- (mean2 - mean1)
    return(statistic)
}



#######
trim <- function (x) gsub("^\\s+|\\s+$", "", x)

#######

KS.score <-
function(expr.data, gene.sets){
    ord <- order(expr.data,decreasing=FALSE)
    expr.data <- expr.data[ord]
    gene.sets <- gene.sets[ord,]
    set.dim <- dim(gene.sets)
    result1 <- rep(0,set.dim[2])
    result2 <- result1
    profile2 <- matrix(0,set.dim[2],set.dim[1])
    expr.data.len <- length(expr.data)
    for(i in 1:set.dim[2]){
        po1 <- which(gene.sets[,i]==1)
        po0 <- which(gene.sets[,i]==0)
        tmp1 <- expr.data
        tmp1[po0] <- 0
        tmp0 <- expr.data
        tmp0[po1] <- 0
        tmp2 <- cumsum(abs(tmp1))/sum(abs(tmp1))
        tmp2b <- tmp1
        tmp2b[po1] <- 1
        tmp2c <- cumsum(tmp2b)/sum(tmp2b)
        tmp0b <- tmp0
        tmp0b[po0] <- 1
        tmp3  <- cumsum(abs(tmp0))/sum(abs(tmp0))
        tmp3b <- cumsum(abs(tmp0b))/sum(abs(tmp0b))
        result1[i]  = max(abs(tmp2c - tmp3b))
        result2[i] = max(abs(tmp2 - tmp3b))
        #profile2.abs <- abs(tmp2 - tmp3b)
        #profile1.abs <- abs(tmp2c - tmp3b)
        #profile2[i,] <- tmp2 - tmp3b
        # profile1 <- tmp2c - tmp3b
    }
    
    out <- list(KS.org = result1,KS.mod = result2)
    
    
}

##########

################

sumTestscore <-
function(expr.data, gene.sets){
    num.classes <- dim(gene.sets)[2]
    Mu <- mean(expr.data)
    sum.score = rep(0,num.classes)
    for(i in 1:num.classes){
        pos1 <- which(gene.sets[,i]==1)
        ##Calculation of sum of squares
        sum.score[i] <- abs(sum(expr.data[pos1]-Mu))
        #sum.score[i] <- sum(expr.data[pos1])
        
    }
    return(sum.score)
}

##############

SS.test.score <-
function(expr.data, gene.sets){
    num.classes <- dim(gene.sets)[2]
    Mu <- mean(expr.data)
    SS.score = rep(0,num.classes)
    for(i in 1:num.classes){
        pos1 <- which(gene.sets[,i]==1)
        ##Calculation of sum of squares
        SS.score[i] <- sum((expr.data[pos1]-Mu)^2)
        #SS.score[i] <- sum((expr.data[pos1])^2)
        
    }
    return(SS.score)
}

##########
###########

emp <-
function(pos.data, neg.data){
    
    neg.dat.sz <- dim(neg.data)
    test_data <- rep(0, neg.dat.sz[2])
    for (k in 1:neg.dat.sz[2]){
        test_data[k] <- length(which(neg.data[,k] >= pos.data[k]))
    }
    test_data[test_data == 0] <- 0.5
    test_data <- (test_data)/(neg.dat.sz[1])
    #test_data <- -log10(test_data)
    test_data
    
    
}

GSZ.p.values <- function(pos.data, perm.data,add=1) {
    # perm data needs to be in permutation x classes format
    # REquire packages ismev (Gumbel distribution fitting)
    # and evd (Generalized Extr. value distribution fitting)
    # TODO: Tosi hidas. Miksi?
    # GEV.p ja EV.p kai toimii. Empiirinen p skitsoilee??
    
    library(ismev)
    library(MASS)
    tmp <- GSZ.adj.mean.std(pos.data, perm.data)
    pos.data <- tmp$pos.out
    perm.data <- tmp$perm.out
    rm(tmp)
    get.perm.p.vals = FALSE
    perm.dat.sz <- dim(perm.data)
    col.ind <- pick.data.cols(perm.data) # discard cols with null var
    #lls()
    # First fit the parameters to the whole data
    perm.data <- perm.data[,col.ind]
    pos.data <- pos.data[col.ind]
    
    
    div.length <- length(perm.data)
    
    emp.p.val.pool <- rep(0, length(pos.data))
    emp.p.val.sep <- get.class.emp.p_vals.gsz(pos.data, perm.data)
    #emp.p.val.sep <- emp_p_val_class(pos.data,perm.data)
    #scaledVariable <- (as.numeric(perm.data)-min(as.numeric(perm.data))+0.001)/(max(as.numeric(perm.data))-min(as.numeric(perm.data))+0.002)
    #t_par_gam <- fitdistr(scaledVariable,'gamma')$estimate
    #param_gam = matrix(0,length(pos.data),2)
    
    for (k in 1:length(pos.data)){
        # Empirical p-value (against pooled permutations)
        #emp.p.val.pool[k] <- emp_p_val3(pos.data[k],perm.data[,k])
        divided <- length(which(perm.data >= pos.data[k]))
        emp.p.val.pool[k] <- log10(div.length+add) - log10(divided+add)
        
        #emp.p.val.pool[k] <- -log(divided/div.length)/log(10)
        
        
    }
    output_select = 2
    if(output_select == 1){
        output <- rbind(gev.p.val, ev.p.val, emp.p.val.pool, gev.p.val.class, ev.p.val.class, emp.p.val.sep)
        rownames(output) <- c("gev.p.val.pooled", "ev.p.val.pooled","emp.p.val.pooled", "gev.p.val.class", "ev.p.val.class", "emp.p.val.class")
    }
    else {
        #qvalue <- qvalue((10^(-emp.p.val.pool)),fdr.level=0.25)$qvalues
        #qvalue <- p.adjust((10^(-emp.p.val.pool)),method="fdr")
        output <- list(EMP.class = emp.p.val.sep,class.ind=col.ind)
        ##output <- list(emp.p_vals = emp.p.val.pool,emp.p_v.class = emp.p.val.sep )
    }
    output
}

GSZ.adj.mean.std <- function(pos.data, perm.data) {
    perm.sz <- dim(perm.data)
    mean.prof <- apply(perm.data, 2, mean)
    std.prof    <- apply(perm.data, 2, sd)
    null.ind <- which(std.prof == 0)   # Remove null dividers
    std.prof[null.ind] <- 0.1
    perm.out <- matrix(0, perm.sz[1], perm.sz[2])
    pos.out <- rep(0, perm.sz[2])
    for( k in 1:perm.sz[2]){
        perm.out[,k] <- ( perm.data[,k] - mean.prof[k]) /std.prof[k]
        pos.out[k]    <- ( pos.data[k] - mean.prof[k] )/std.prof[k]
    }
    out  <- list(pos.out = pos.out, perm.out = perm.out)
    out
}


get.class.emp.p_vals.gsz <- function(pos.data, neg.data,add=1){
    
    # GSZ post-processing. This function reports separate
    # empirical p-value when pos. result is compared against
    # the class specific permutations
    
    neg.dat.sz <- dim(neg.data)
    test_data <- rep(0, neg.dat.sz[2])
    for (k in 1:neg.dat.sz[2]){
        test_data[k] <- length(which(neg.data[,k] >= pos.data[k]))
    }
    #test_data[test_data == 0] <- 0.5
    #print(neg.dat.sz[1])
    test_data <- log10(neg.dat.sz[1]+add)-log10(test_data+add)
    
    test_data
    
    
}

